
//	Copyright (c) 1982 Dyadic Systems Limited	

#include <machine.h>

#include <setjmp.h>
#include <signal.h>

#if	defined(DOS)
#include <dos_comms.h>
#elif	defined(WATCOM)
#	if	defined(__NT__)
		extern void * parentid;			// HANDLE
#	else
		extern unsigned short parentid;		// HANDLE
#	endif
#	define INPIPE	((unsigned)parentid)
#	define OUTPIPE	((unsigned)parentid)
#endif	// DOS 

#ifdef	INPIPE			// eg apollo wants to override these    
#define ARGSPIPE INPIPE
#define RSLTPIPE OUTPIPE
#else
#define ARGSPIPE 3		// pipe allocations			
#define RSLTPIPE 4
#endif	// INPIPE 

				// function syntax			
#define	RSLT	0040		// returns a result			
#define	SHYR	0140		// returns a shy result			
#define	NILA	0000		// takes no arguments			
#define	MONA	0004		// takes only a right argument		
#define	DYAD	0014		// takes a left and right argument	
#define	OPTL	0034		// left argument is optional (ambivalent)
#define	INTR	0200		// handles its own interrupts		
#define	XWID	0400		// request to return apl's X window ID  

#define ALIGNWD(A) unsigned:sizeof(unsigned)*8-A

typedef struct			// an APL ARRAY				
{
	unsigned length;	// total length in words including self	
	unsigned type	:4;	// see below				
	unsigned rank	:4;	// rank of array			
	unsigned eltype	:4;	// type of all the elements (see below)	
	ALIGNWD(12);		// word align for 68000			
	unsigned shape[1];	// rho vector - really shape[rank]	
} ARRAY;

#define SIMPLE 0xf		// APL ARRAY types			
#define NESTED 0x7

#define	CHAR	0		// APL ARRAY eltypes			
#define	BOOL	1
#define	SINT	2
#define	INTG	3
#define	LONG	4
#define	DOUB	5
#define	PNTR	6

#define	WSFULL		1	// APL error codes			
#define	SYNTAX		2
#define	INDEX		3
#define	RANK		4
#define	LENGTH		5
#define	VALUE		6
#define	LIMIT		10
#define	DOMAIN		11
#define	NONCE		16
#define	NOPIPES		30
#define	NOPROCS		76
#define AP_EXIT		77
#define	FERR		100
#define	INTERRUPT	1003
#define	EOF_INTERRUPT	1005

				// NB error codes 200-500 are reserved	
				// for distributed auxiliary processors	
#define	PRE_ERRBASE	200	// 		prefect			
#define	VIA_ERRBASE	220	// 		via			
#define	XUT_ERRBASE	240	// 		xutils			
#define	QFS_ERRBASE	260	//		qfsck			
#define CGI_ERRBASE	280	//	cgi - taking next 53 errors	
#define NFL_ERRBASE	360	//	nfiles - taking next 20 errors	
#define PRT_ERRBASE	400	//	prt - taking the next 30 errors	


//	Copyright (c) 1982 Dyadic Systems Limited	

