//	Copyright (c) 1982 Dyadic Systems Limited	
#define MAXRANK		15	// causes circular include problems if	
				// defined in pocket.h			

#define APLBUSY (AplBusy())

//	Macros which may be overridden by machine.h	

#ifdef	SYSTEM_V
#define	BELL
#endif	// SYSTEM_V 

#ifdef	SYSTEM_III
#define	BELL
#endif	// SYSTEM_III 

#ifndef	VOLATILE
#define	VOLATILE	volatile
#endif	// VOLATILE 

#ifndef	SIGNED			// Can cast default char type to be	
#define	SIGNED	unsigned		// signed or unsigned if needed		
#endif	// SIGNED 

#ifdef	XAPL
#define	GUI 1
#endif	// XAPL 

#ifdef	WINDOWS3
#define	GUI 1
#endif	// WINDOWS3 

#ifndef	GUI
#define	GUI 0
#endif	// GUI 

#ifndef _CONSOLE
#define	_CONSOLE 0
#endif//_CONSOLE

#if	_CONSOLE
#	undef	GUI
#	define	GUI 0
#endif//_CONSOLE

#ifndef	SIGTYPE			// the type of a signal-catcher routine	
#define	SIGTYPE		void	// ANSI says void, SYS V says void, older 
#endif	/* SIGTYPE			 *//* versions may need int		*/

#ifndef	SIGHANDSHAKE
#define SIGHANDSHAKE	SIGTERM
#endif	// SIGHANDSHAKE 

#ifdef	DALIGN			// If the machine requires double 	
#define	WSDALIGN		// alignment, define WorkSpace		
#endif	/* DALIGN			 *//* alignment also.			*/

#ifndef MAXUNSIGNED		// some machines don't support unsigned	
#define MAXUNSIGNED	~0	// well - if so set to the maximum	
#endif	/* MAXUNSIGNED		 *//* possible default (signed) integer	*/

#ifndef MAXSTRONG
#define MAXSTRONG	10
#endif	// MAXSTRONG 

#ifndef MAXFCHARS		// max characters in full path name	
#define MAXFCHARS	128
#endif	// MAXFCHARS 

#ifndef	SMLOGSIZ		// characters in session manager's log	
#define	SMLOGSIZ	81920	// 10240 until 1994-07-08
				// 40960 until 1998-09-15
#endif	// SMLOGSIZ 

#ifndef	PFKBUFSIZ		// characters in pfkey buffer		
#define	PFKBUFSIZ	2048
#endif	// PFKBUFSIZ 

#ifndef	GREENBUFSIZ		// characters in input line buffer	
#define	GREENBUFSIZ	4096
#endif	// GREENBUFSIZ 

#ifndef	HISTBUFSIZ		// characters in input history buffer	
#define	HISTBUFSIZ	2048
#endif	// HISTBUFSIZ 

#ifndef	CUTBUFSIZ		// characters in cut / paste buffer	
#define	CUTBUFSIZ	256
#endif	// CUTBUFSIZ 

#ifndef	getenv			// enable enviroment defaults and overrides 
#	define getenv	shad_getenv
	extern  char *shad_getenv(const char *);
#endif	// getenv 

#ifndef	DINT
#define DINT		LONG	// 4 byte default integers		
#define dint		l	// access via hold.l			
#define dintp		lp	// ptr via ptr.lp			
#define pget_p		lget_l	// access using lget_l()		
#define dint_t		long	// use long type
#endif	// DINT 

#if	!defined(PNTRlog)
#	define PNTRlog		5	// 32 bit pointers		
#endif

#define	dzero		d	// comparison of doubles against 0	

#ifndef BYTE3210		// VAX, NS32000 etc			
#ifndef	BYTE2301
#ifndef BYTE1032
#define BYTE0123		// M68000, Z8000 etc			
#endif	// BYTE1032 
#endif	// BYTE2301 
#endif	// BYTE3210 

//	which short in a double contains the exponent			
//	see the code for testnan()					
#ifndef	EXP_SHORT
#	ifdef	BYTE0123
#		define	EXP_SHORT	0
#	endif	// BYTE0123 

#	ifdef	BYTE3210
#		define	EXP_SHORT	3
#	endif	// BYTE3210 
#endif	// EXP_SHORT 

#ifndef	DRAND			// consider whether this is needed (see	
#ifndef	BYTE0123		// the code of rand.c). must be defined	
#define	DRAND			// if bytes in strange order		
#endif	// BYTE0123 
#endif	// DRAND 

#ifdef	BELL
#ifndef	TIMEOV			// Consider whether this is needed (see	
#endif	/* TIMEOV			 *//* tty.c). unlikely to be required	*/
#endif	// BELL 

#ifndef	HERTZ			// This gives the frequency of the CPU	
				// line (interrupt) clock.  You may	
				// need to define it if it is not	
				// already defined in a system include	
				// file.  It will default to 60.  It is	
				// used in cpu() (in util.c) to convert	
#endif	/* HERTZ			 *//* clock ticks to msec for quadAI[2].	*/

#ifdef	BSD
#define strrchr		rindex	// string(3) difference			
#define strchr		index	// string(3) difference			
#define LS_C			// always use "ls -C" on BSD machines	
#endif	// BSD 

#ifndef	WORDALIGN		// used in scan.c & quadvfi.c		
#define	WORDALIGN 	int
#endif	// WORDALIGN 

// some machines e.g. CADSOFT can't cope with some register types	

#ifndef	REGDOUB
#define REGDOUB 	register double
#endif	// REGDOUB 

#ifndef	REG_UNION
#define REG_UNION	register union
#endif	// REG_UNION 

/* define REG_VFN if machine can't handle register void function pointers
e.g.	#define	REG_VFN void
or	#define	REG_VFN register
or	#define	REG_VFN	int
*/

#ifndef	REG_VFN
#define	REG_VFN		register void
#endif	// REG_VFN 

#ifndef	REG_IFN
#define	REG_IFN		register int
#endif	// REG_IFN 

// some machines (SPS7) get pointer comparisons wrong			

#ifndef	NULLP
#define	NULLP(x)	((x) == 0)
#endif	// NULLP 

#ifndef	CMPTR
#define	CMPTR(l, op, r)	((l) op (r))
#endif	// CMPTR 

// some machines e.g. ZILOG cant cope if brk() fails 

#ifdef	BRK_ERR			// This defines the action to be taken	
				// if brk(2) ever fails.  On Zilog and	
				// Tower XP define it as syserror(2),	
				// otherwise UNIX will crash when brk()	
#endif	/* BRK_ERR			 *//* fails.				*/

// derive standard value for MACHINETYPE 

#ifdef	Ieee
#	ifdef	BYTE3210
#		ifdef	UNSINT
#			ifdef	DALIGN
#			define	MACHINETYPE	0xf	// non known 
#			else//  
#			define	MACHINETYPE	0xe	// non known 
#			endif	// DALIGN 
#		else//  
#			ifdef	DALIGN
#			define	MACHINETYPE	0xd	// non known 
#			else//  
#			define	MACHINETYPE	0xc	// Nat Semi, Intel 
#			endif	// DALIGN 
#		endif	// UNSINT 
#	else//  
#		ifdef	UNSINT
#			ifdef	DALIGN
#			define	MACHINETYPE	0xb	// sps9 (Ridge) 
#			else//  
#			define	MACHINETYPE	0xa	// 6150		
#			endif	// DALIGN 
#		else//  
#			ifdef	DALIGN
#			define	MACHINETYPE	0x9	// Sun4, HP800	
#			else//  
#			define	MACHINETYPE	0x8	// most common	
#			endif	// DALIGN 
#		endif	// UNSINT 
#	endif	// BYTE3210 
#else//  
#	ifdef	BYTE3210
#		ifdef	UNSINT
#			ifdef	DALIGN
#			define	MACHINETYPE	0x7	// non known 
#			else//  
#			define	MACHINETYPE	0x6	// non known 
#			endif	// DALIGN 
#		else//  
#			ifdef	DALIGN
#			define	MACHINETYPE	0x5	// non known 
#			else//  
#			define	MACHINETYPE	0x4	// Vax 
#			endif	// DALIGN 
#		endif	// UNSINT 
#	else//  
#		ifdef	UNSINT
#			ifdef	DALIGN
#			define	MACHINETYPE	0x3	// non known 
#			else//  
#			define	MACHINETYPE	0x2	// non known 
#			endif	// DALIGN 
#		else//  
#			ifdef	DALIGN
#			define	MACHINETYPE	0x1	// Gould 
#			else//  
#			define	MACHINETYPE	AARGH!	// none allowed 
#			endif	// DALIGN 
#		endif	// UNSINT 
#	endif	// BYTE3210 
#endif	// Ieee 

// derive new architecture type for WS_VER 7 onwards 

#define	ARCH_LITTLE		0x80
#define	ARCH_DEXTEND		0x40
#define	ARCH_64BIT		0x20
#define	ARCH_DALIGN		0x10
#define	ARCH_UNICODE		0x08

#if	defined(BYTE3210)
#	define	ARCH_BIT_8	ARCH_LITTLE
#else
#	define	ARCH_BIT_8	0
#endif

#if	defined(LONGDOUBLES)
#	define	ARCH_BIT_7	ARCH_DEXTEND
#else
#	define	ARCH_BIT_7	0
#endif

#if	6 == PNTRlog
#	define	ARCH_BIT_6	ARCH_64BIT
#else
#	define	ARCH_BIT_6	0
#endif

#if	defined(DALIGN)
#	define	ARCH_BIT_5	ARCH_DALIGN
#else
#	define	ARCH_BIT_5	0
#endif

#if	defined(UNICODE)
#	define	ARCH_BIT_4	ARCH_UNICODE
#else
#	define	ARCH_BIT_4	0
#endif

#if defined(MAINWIN)
#	define PRODUCT_NAME "Dyalog APL/M"
#else
#	if defined(WINDOWS3)
#		define PRODUCT_NAME "Dyalog APL/W"
#	else
#		define PRODUCT_NAME "Dyalog APL"
#	endif
#endif

#define NONAMELESSUNION

#if	defined(__NT__)

#undef PP0CHK

#define MK_FP32(p)	(p)
#define MoveTo(h,x,y)	MoveToEx(h,x,y,0);
#define SetWindowOrg(h,x,y)	SetWindowOrgEx(h,x,y,0);
#define SetWindowExt(h,x,y)	SetWindowExtEx(h,x,y,0);
#define SetViewportOrg(h,x,y)	SetViewportOrgEx(h,x,y,0);
#define SetViewportExt(h,x,y)	SetViewportExtEx(h,x,y,0);
#define OffsetViewportOrg(h,x,y)	OffsetViewportOrgEx(h,x,y,0);
#define SetBrushOrg(h,x,y)	SetBrushOrgEx(h,x,y,0);

// ISO + WATCOM
#define	_fstrcat	strcat
#define	_fstrchr	strchr
#define	_fstrcmp	strcmp
#define	_fstrcoll	strcoll
#define	_fstrcpy	strcpy
#define	_fstrcspn	strcspn
#define	_fstricmp	stricmp
#define	_fstrlen	strlen
#define	_fstrlwr	strlwr
#define	_fstrncat	strncat
#define	_fstrncmp	strncmp
#define	_fstrncpy	strncpy
#define	_fstrnicmp	strnicmp
#define	_fstrnset	strnset
#define	_fstnspn	strnspn
#define	_fstrrstr	strrstr
#define	_fstrrev	strrev
#define	_fstrset	strset
#define	_fstrspn	strrspn
#define	_fstrtok	strtok
#define	_fstrupr	strupr

// just the ISO ones
#define	_fmemchr	memchr
#define	_fmemcmp	memcmp
#define	_fmemcpy	memcpy
#define	_fmemmove	memmove
#define	_fmemset	memset

#endif	// __NT__ 

#if defined(DOSWIN)
#	define	DIRDELIM	'\\'
#	define	PATHDELIM	';'
#	define 	PATHDELIMSTR 	";"
#else
#	define	DIRDELIM	'/'
#	define	PATHDELIM	':'
#	define 	PATHDELIMSTR 	":"
#endif

#define	ARCH	(ARCH_BIT_8 | ARCH_BIT_7 | ARCH_BIT_6 | ARCH_BIT_5 | ARCH_BIT_4)

typedef unsigned char UCHAR;
#define UNS	unsigned
#define REG	register

//	Copyright (c) 1982 Dyadic Systems Limited	
