
#include	"apl.h"
#include	"support.h"

unsigned char taskid[] = "example";

#if	defined(DOS)
	main()
#elif	defined(WINDOWS3)
	win_main(int argc, unsigned char *argv[])
#else
	main(argc, argv)
	int	argc;
	unsigned char	*argv[];
#endif
{
	ARRAY	*rslt, *larg, *rarg,
		*getarray(), *freearray(),
		*idn_d(), *d_idn();
	int	fncode;

	startup(1);
	define("IDN_TO_DATE", RSLT|OPTL, 1);
	// define("DATE_TO_IDN", RSLT|MONA, 2);

	larg = rarg = rslt = 0;
	setjmp(errbuff);

	while(1)
		{
		larg = freearray(larg);
		rarg = freearray(rarg);
		rslt = freearray(rslt);

		fncode = fromapl();

		switch(fncode)
			{
			case -1:		// AP about to be terminated 
				toapl(0);	// Signal go-ahead to apl    
				fromapl();	// and wait for kill	     
				exit(0); 	// ( For DOS version only. ) 
			case 1:
				larg = getarray();
				rarg = getarray();
				rslt = idn_d(larg,rarg);
				break;
			case 2:
				rarg = getarray();
				rslt = d_idn(rarg);
				break;
			}
		putarray(rslt);
		}
}

ARRAY	*idn_d(larg, rarg)	// international day number to date 
ARRAY	*larg, *rarg;
{

	ARRAY		*rslt;
	unsigned char	*cptr, *format;
	int 		(*makedint)(), (*initdint())();
	int		year, day, leap, i, numchars;
	unsigned	idn;

	static int day_tab[2][13] =
			{
		{0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31},
		{0, 31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31}
			};
	static unsigned char month[][4] =
			{
	"Nul", 	"Jan", "Feb", "Mar", "Apr", "May", "Jun",
		"Jul", "Aug", "Sep", "Oct", "Nov", "Dec"
			};
	static unsigned char cbuf[12];

	if(larg)
		{
		numchars = 11;
		format = "%02d %s %4d";
		}
	else
		{
		numchars = 9;
		format = "%02d %s %02d";
		}

	if(rarg->type == NESTED || rarg->eltype == CHAR) error(DOMAIN);
	if(rarg->rank > 1) error(RANK);
	if(rarg->rank && arraybound(rarg) != 1) error(LENGTH);

	makedint = initdint(rarg);
	idn = (*makedint)((int *)arraystart(rarg),0);

	year = idn/365;
	day = (idn - year*365) - ((year == 0) ? year : year-1)/4;
	year = year - (day <= 0);
	leap = ((year%4 == 0) && (year%100 != 0)) || (year%400 == 0);
	day = day + (day <= 0) * (365 + leap); 

	for(i = 1; day > day_tab[leap][i]; i++) day -= day_tab[leap][i];

	rslt = mkarray(CHAR, 1, &numchars);
	cptr = arraystart(rslt);
	sprintf(cbuf, format, day, month[i], larg ? 1900+year : year);
	for(i = 0; i < numchars; i++) *cptr++ = unixtoav(cbuf[i]);

	return rslt;
}

ARRAY	*d_idn(rarg)		// date to international day number 
ARRAY	*rarg;
{
	ARRAY		*rslt;
	unsigned char	*strcpy(), avdate[11], uxdate[11];
	unsigned char 	mnth[4];
	int		day, year, leap;
	int		i, mno, zero;

	static int day_tab[2][13] =
			{
		{0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31},
		{0, 31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31}
			};

	static unsigned char month[][4] =
			{
	"Nul", 	"Jan", "Feb", "Mar", "Apr", "May", "Jun",
		"Jul", "Aug", "Sep", "Oct", "Nov", "Dec"
			};

	if(rarg->rank != 1) error(RANK);
	if(rarg->eltype != CHAR) error(DOMAIN);
	if(rarg->shape[0] > 11) error(LENGTH);

	strncpy(avdate, arraystart(rarg), rarg->shape[0]);
	avdate[rarg->shape[0]] = '\0';
	for(i=0; i<11; i++) uxdate[i] = avtounix(avdate[i]);
	sscanf(uxdate, "%d %3s %d", &day, mnth, &year);

	mno = 1;
	while((strcmp(mnth, month[mno]) != 0) && mno <= 12) ++mno;

	if (mno > 12) error(DOMAIN);
	year = (year > 1900) ? (year-1900) : year;
	if ((year < 0) || year > 99 ) error(DOMAIN);
	leap = ((year%4 == 0) && (year%100 != 0)) || (year%400 == 0);
	if ((day < 1) || day > day_tab[leap][mno]) error(DOMAIN);

	for(i = 1; i < mno; i++) day += day_tab[leap][i];
	day = day + (365 * year) + (year - 1) / 4;

	zero = 0;
	rslt = mkarray(LONG, 0, &zero);
	rslt->shape[0] = day;

	return rslt;
}
