// processed by mwprepro or mwpreproC 
/*
	Defines the structure of a compiled keyboard map file
*/

#ifndef GETUCHAR
#include	<sys/types.h>	// may be already included 
#endif  // GETUCHAR 

#ifdef __NT__
#undef IN
#endif

#define NOKEY 	32767

struct Mmap
	{
	unsigned char istemp;	// is a temporary mode ? 
	unsigned char doistrip;	// strip top bit ? 
	unsigned char isatty;	// attached to a tty 
	unsigned char pad;	// keep 4 byte allignment 
	unsigned char direct[32];// 256 bits 1 => return char is in 
	short char_or_index[256];// here else this contains row no 
	short rows;		// rows in strs 
	short cols;		// cols in strs 
	short *result;			// pntr into dynamic area 
	unsigned char strs[4];		// dynamic area 
	};
	
struct Imap
	{
	union
		{
		unsigned char magic[2];		// Magic number for file(1) 
		struct
			{
/* set at run time */	ino_t	inode;		/* resident inode	*/
/* set at run time */	dev_t	device;		/* and the device it is on */
			} file;		// sizeof(struct file) <= 8 !!! 
		unsigned char space[8];		// size of the union 
		} header;
	unsigned char n_modes;		// Number of Modes 
	unsigned char weak_int;		// Weak interrupt character 
	unsigned char strong_int;	// Strong interrupt character 
	unsigned char prog_mode;	// Mode for programmer input 
	unsigned char user_mode;	// Mode for user input 
	unsigned char n_labs;		// How many labels are defined 
	unsigned char caps_on;		// flag caps on 
	unsigned char pad[1];		// Keep nice 4 byte allignment 
	unsigned char is_lower[32];	// space for 256 bits 
	unsigned char caps_xchg[256];	// Caps lock exchange table 
	struct Mmap *mode[16];		// pntrs into dynamic area 
	unsigned char *labinfo;		// pntr into dynamic area 
	};

struct Fd_map
	{
	struct Imap *map;
	unsigned char curr_mode[2];	// [0] <-> programmer, [1] <-> user 
	};

extern int inkey();		// read a key stroke 
	/* eg  
		k = inkey((int)fd, (unsigned)PROG);
	*/
extern unsigned keyset();	// report and set mode 
	/* eg
		was = keyset((int)fd, (unsigned)willbe, (unsigned)USER);
	*/
extern unsigned char *inlab();		// label on key 
	/* eg
		l = inlab(0, 5)
	*/

//	Special Functions	
	
#define	 WI  -1		// Weak Interrupt 
#define  SI  -2		// Strong Interrupt 
#define  QT  -3		// Quit 
#define  ER  -4		// Enter 
#define  TB  -5		// Horizontal Tab 
#define	 BT  -6		// Back Tab 
#define  EP  -7		// Escape 

#define  UC  -8		// Up Character 
#define  DC  -9		// Down Character 
#define  RC  -10	// Right Character 
#define  LC  -11	// Left Character 

#define  US  -12	// Up Screen 
#define  DS  -13	// Down Screen 
#define  RS  -14	// Right Screen 
#define  LS  -15	// Left Screen 

#define  UL_ -16	// Up Limit 
#define  DL_ -17	// Down Limit 
#define  RL_ -18	// Right Limit 
#define  LL_ -19	// Left Limit 

#define	 HO  -20	// Home Cursor 
#define  CT  -21	// Cut 
#define  PT  -22	// Paste 

#define  IN  -23	// Insert Mode Toggle 
#define  II  -24	// Insert Item 
#define  DI  -25	// Delete Item 
#define  DP  -26	// Destructive Space 
#define  DB  -27	// Destructive Backspace 
#define  RD  -28	// Redraw Screen 

#define  TG  -29	// Tag 
#define  DK  -30	// Delete Block 
#define  OP  -31	// Open 
#define  CP  -32	// Copy 
#define  MV  -33	// Move Block 

#define  FD  -34	// ForwarD 
#define  BK  -35	// BacKward 

#define  ZM  -36	// ZooM 

#define  SC  -37	// Search 
#define  RP  -38	// Replace 
#define  NX  -39	// Next 
#define  PV  -40	// Previous 

#define  RT  -41	// Repeat 
#define  RA  -42	// Repeat all 

#define  ED  -43	// Edit 
#define  TC  -44	// Trace 

/* Following not used from 5.3 onwards but must keep them for existing
 * quadsm users who might just be using them as exit keys 
 */

#define  NB  -45	// Non Destructive Backspace 
#define  NS  -46	// Non Destructive Space 
#define  ST  -47	// Start of Line 
#define  EN  -48	// End of line 
#define  IF  -49	// Insert off 

// Late additions 

#define  HK  -50	// Hot Key 
#define  FX  -51	// Function Fix 
#define  LN  -52	// Line Numbers 

#define  MC  -53	// Mode Change	
#define  MR  -54	// Move / Resize 

// Very Late additions 

#define  JP  -55	// JumP 

#define ILLEGAL -87024	// use random number as flag for illegal 
#define MTQUEUE -87023	// use random number as flag for no key  


// XAPL Mouse QuadSM exit keys 
#define	D1   -56
#define	D2   -57
#define	D3   -58
#define	D4   -59
#define	D5   -60
#define	U1   -61
#define	U2   -62
#define	U3   -63
#define	U4   -64
#define	U5   -65

// GUI text selection keys 

#define LCS	-66		// left cursor with selection 
#define RCS	-67		// right cursor with selection 
#define LW	-68		// left word 
#define RW	-69		// right word 
#define LWS	-70		// left word width selection 
#define RWS	-71		// right word with selection 
#define UCS	-72		// up cursor with selection 
#define DCS	-73		// down cursor with selection	 
#define LLS	-74		// select to start of line 
#define RLS	-75		// select to end of line 
#define ULS	-76		// select to top 
#define DLS	-77		// select to bottom 
#define USS	-78		// select up a page 
#define DSS	-79		// select down a page 
#define DD	-80		// Drag and drop selection 
#define DH	-81		// Delete Highlighted selection 

// end of GUI text selection keys

#define BH	-82		 
#define BP	-83		// set breakpoint 
#define AB	-84		// ABORT 

// Indent / Undent 

#define HT	-85
#define TH	-86

#define	RM	-87		// resume  
#define	CBP	-88		// clear break points  
#define	PRP	-89		// show object properties

// quadsr/dq exit specials 	

#define	TERMSR_CONTINUE	-90
#define	TERMSR_STOP	-91

#define	TGL	-92		// toggle localisation

#define	UA	-93		// undo all changes

//	Function Keys	

#define  F0     -96

//	Go to Mode Mn	

#define  M0   -512

//	Old-style Labels on Function Keys	

#define	 L0 -1024


//	Special attributes	

#define	 PROG	 -2048
#define  USER    -2049





/*
	Defines the structure of a compiled output translate map file

	+-------------------------------------------------------+
o_out	|	|   *	|   *	|	|	|   *	|	| one per _NFILE
	+-------------------------------------------------------+
		    |	    |			    |
		    +-------+			    |
			|			    |
	+-----------------------+	+-----------------------+
struct	| 			|	|			| one per
 Out_fd	|			|	|			|  device/inode
	|			|	|			|
	|			|	|			|
	|			|	|			|
	|			|	|			|
	| *t_out		|	| *t_out		|
	+-----------------------+	+-----------------------+
		|				|
		|				|
		+-------------------------------+
				|
				|
			+---------------+
struct Translate	|		| one per translate file required
			|		|
			|		|
			|		|
			|		|
			|		|
			+---------------+

*/

struct Sas				// Special Action String 
	{
	short code;			// suitable negative code eg B3 
	unsigned short offset;		// offset from strstart		
	unsigned short len;		// length of string (keep alignment) 
	};

struct Translate
	{
	ino_t	inode;			// inode of translate file	
	dev_t	device;			// device it resides on		
	unsigned nmodes;		// number of modes		
	unsigned nsas;			// number of non-moded strings	
	struct Sas *special;		// special action strings	
	short unsigned *offset;		// point to start of offsets	
	unsigned char *lengths;		// point to start of lengths	
	unsigned char *strstart;	// point to start of strings	
	unsigned char dynamic[1];	// dynamic area			
	};

struct Out_fd
	{
	struct	Translate *t_out;	// selected translate table	
	ino_t	out_ino;		// talking to this inode	
	dev_t	out_dev;		// and this device		
	unsigned char out_used;		/* used this device for translated
					   output */
	unsigned short curr_col;	// current col to handle line feeds
#ifdef	DOS
	unsigned char is_dos_console;	// hook for fscreen io 
#else//  
	unsigned char unused;
#endif	// DOS 
	};

/* I am outlawing the possibility of talking to the same device with different
 * translate tables
 */

extern struct Out_fd *o_out[];

//	non moded string codes 

#define	INIT	-1
#define	RESET	-2

#define	V0	-768		// videos 
#define	C0	-1024		// foreground colours 
#define	B0	-1280		// background colours 

//	moded string codes	

//	DANGER - these values are likely to be very unstable 

#define	CC	256	
#define MODE0	257	// start of mode switching area 
			// user label is M0	


struct Datemap
	{
	ino_t	inode;			// inode of translate file	
	dev_t	device;			// device it resides on		
	unsigned n_days;		// number of weekday strings	
	unsigned n_months;		// number of month strings	
	unsigned n_formats;		// number of format strings	
	unsigned n_labels;		// number of format labels	
	struct Sas *strings;		// special action strings	
	unsigned char *strstart;	// point to start of strings	
	unsigned char dynamic[1];	// dynamic area			
	};

	/*
	 * Date format bases
	 */

#define D0	-128
#define MN0	-256
#define DF0	-512
#define DL0	-768

extern unsigned char *get_date_string(short);
extern unsigned short get_date_length(short);
