// processed by mwprepro or mwpreproC 

//	Copyright (c) 1982 Dyadic Systems Limited	

/*
	Translate tables and support functions
*/
#include <stdlib.h>
#include <string.h>

#include <machine.h>

#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <malloc.h>
#include <assert.h>
#include <setjmp.h>

#if	defined(DOS)
#	if	defined(WATCOM)
#	include	<io.h>
#	include	<fcntl.h>
#	endif	// defined(WATCOM) 
#	include <hardware.h>	// get this before io_maps.h 
#endif	// defined(DOS) 
#include <io_maps.h>		// input/output mapping structure 
#include <quadav.h>
#include <trans.h>		// Standard translate tables		

#include <jumps.h>
#include <malloc.h>
				// extra tables are defined below	
#ifdef	BELL
#include <fcntl.h>
#define	FCNTL
#endif	// BELL 

#ifdef	BSD
#include <fcntl.h>
#define	FCNTL
#endif	// BSD 

#ifndef	INPIPE			// allow machines to override (APOLLO)	
#define	INPIPE	3
#define	OUTPIPE	4
#endif	// INPIPE 

#ifndef	_NFILE
#define	_NFILE 20 		// should be in an include file		
#endif	// _NFILE 

#define	MAX_BUF		(32*1024)
#define T_WKBFSZ	(32*1024)

#define BIT_READ(vec, i)	(vec[(i) >> 3] & (0x80 >> ((i) & 7)))
#define BIT_FLIP(vec, i)	(vec[(i) >> 3] ^= (0x80 >> ((i) & 7)))

unsigned char avtounix(unsigned char c);
unsigned char unixtoav(unsigned char a);
void o_init(void);
void o_filbuf(void);
void i_filbuf(void);

void ansi2av(unsigned char *cptr, int size);
void av2ansi(unsigned char *cptr, int size);

unsigned char FOREGROUND[256][3], BACKGROUND[256][3];
unsigned char WINCHARS[256];	// cached screen output translate
				// also supports avtounix()

static unsigned char BODGECHARS[256]; // support backwards translation of output
				// translate file. Has all sorts of problems
				// but needed until we write our own edit
				// box widget.
static unsigned cached;


unsigned unixstr2av(void * dest, void * src, unsigned maxchars)
	{
	unsigned char *d = dest;
	unsigned char *s = src;
	unsigned count = 0;

	for
		(
		--d
	,	--s
	,	++maxchars
	;	--maxchars && *++s
	;	*++d = unixtoav(*s)
	,	++count
		);
	return count;
	}


/*	unixtoav()
 *
 * Converts input known to be ASCII to APL internal form (QuadAV)
 *
 */

unsigned char unixtoav(unsigned char a)
{
	return cached ? BODGECHARS[a] : asciimap[a];
}

/*	avtounix()
 *
 * Converts an APL character to an ASCII equivalent graphic if
 * possible.
 *
 */

static unsigned hexvalue(unsigned char hc)
	{
	if('0' <= hc && '9' >= hc) return hc - '0';
	if('a' <= hc && 'f' >= hc) return 10 + hc - 'a';
	if('A' <= hc && 'F' >= hc) return 10 + hc - 'A';
	error(11);
	return 0;	// keep the compiler happy
	}

unsigned char avtounix(unsigned char c)
{
	if(cached)
		{
		static unsigned first = 1;
		static unsigned char map[256];

		if(first)
			{
			unsigned char *mapchars = (void *)getenv("MAPCHARS");
			unsigned i;
			unsigned len = mapchars ? strlen(mapchars) : 0;

			for( i = 256; --i, map[i] = i, i;); // init identity map
			len &= ~3;		// must must be a multiple of 4
			for(;len;)
				{
				unsigned mapval;
				unsigned location;

				mapval = hexvalue(mapchars[--len]);
				mapval += 16 * hexvalue(mapchars[--len]);
				location = hexvalue(mapchars[--len]);
				location += 16 * hexvalue(mapchars[--len]);
				if
					(
					256 > location
				&&	256 > mapval
					)
					{
					map[location] = mapval;
					}
				}
			first = 0;
			}
		return WINCHARS[map[c]];
		}
	else
		{
		return unixtab[c];
		}
}

void avtow3(unsigned char *av)
{
unsigned char *op;
for (op = av ; *av ; *op++ = avtounix(*av++));
}

void w3toav(unsigned char *av)
{
unsigned char *op;
for (op = av ; *av ; *op++ = unixtoav(*av++));
}

void AVtoW3(unsigned char *av,int len)
{
for (;len--;*av=avtounix(*av),av++);
}

void W3toAV(unsigned char *av,int len)
{
for (;len--;*av=unixtoav(*av),av++);
}

void ToUpper(char *cp)
{
while (*cp)	
	{
	*cp = toupper(*cp);
	cp++;
	}
}                        

unsigned char in_word_specials[] = {POINT, QUAD,UNDER,DELTA,DELTAU,HIGH,
		0x81, 0x82, 0x83, 0x84,		//National language chars
		0x86, 0x87, 0x88, 0x89, 0x8A, 0x8B, 0x8C, 0x8D, 0x8E, 0x8F,
		0x90, 0x91, 0x92, 0x93, 0x94, 0x95, 0x96, 0x97, 0x98, 0x99,0x9A,
		0xD3, 0xD4, 0xD5, 0xD6,
		0xE8, 0xE9, 0xEA,
		0xEC, 0xFF, 0};
			//Added national language chars for prob 1865, cvc,aug99


int _in_word(unsigned char c, unsigned char *specials)
{	//Function added with fix to problem 1865, (RW not working)
return (
	(c>=ZERO && c<=NINE)	||
	(c>=AL   && c<=ZL)	||
	(c>=AU   && c<=ZU)	||
	(c>=A    && c<=Z)	||
	strchr(specials,c)
	);

}

int in_word(unsigned char c)
{
return _in_word(c,&in_word_specials[0]);
}


int avtoupper(int c)
{
if (c >= AL && c <= ZL)
	c += (A-AL);

return c;
}

void AVtoUpper(char *cp,int len)
{
while (len--)
	*cp++ = avtoupper(*cp);
}

char *_strncpy(char *dst,char *src,int len)
{
strncpy(dst,src,len);
dst[len-1]=0;
return dst;
}

int _avstrncmp(char *s1,char *s2,int len)
{
while (len--)
	{
	if ((*s1) < (*s2))
		return -1;
	else if ((*s1) > (*s2))
		return 1;
	s1++;
	s2++;
	}
return 0;
}
int avstrncmpi(char *s1,char *s2,int len)
{
while (len--)
	{
	if (avtoupper(*s1) < avtoupper(*s2))
		return -1;
	else if (avtoupper(*s1) > avtoupper(*s2))
		return 1;
	s1++;
	s2++;
	}
return 0;
}

int avstrcmpi(unsigned char *s1,unsigned char *s2)
{
while (*s1 || *s2)
	{
	if (avtoupper(*s1) < avtoupper(*s2))
		return -1;
	else if (avtoupper(*s1) > avtoupper(*s2))
		return 1;
	s1++;
	s2++;
	}
return 0;
}

int avstrcmp(unsigned char *s1,unsigned char *s2)
{
while (*s1 || *s2)
	{
	if (*s1 < *s2)
		return -1;
	else if (*s1 > *s2)
		return 1;
	s1++;
	s2++;
	}
return 0;
}


/*	avstrncmp
	Same as strncmp, only compares from (assumed to be quadAV string)
	with to (assumed to be UNIX string).
	Returns -1 if from is sorted before to, +1 if from is sorted
	after to, and 0 if from and to are equal.
*/
int avstrncmp(unsigned char *from, unsigned char *to, unsigned max)
{
	while (max--)
	    {
	    unsigned char sch, dch;
	    sch = *from++;
	    dch = *to++;
	    if (sch < unixtoav(dch))
		return -1;
	    else if (sch > unixtoav(dch))
		return 1;
	    }
	return 0;		// strings are equal	
}




/*	asctoav()
 *
 * Maps the input from an ascii device.  Note that on a UTS system,
 * it is the calling codes responsibility to ensure aplmode == 0
 * if the terminal is a tube (3278-type device).
 *
 */

/*	N.B.
 *	this code supports oddball translates now that the input
 *	mapping supports keyboards. This code is still used for
 *	things like converting ap function names when they are
 * 	defined into the workspace by quadSH.
 */

unsigned char asctoav(a,aplmode)
unsigned aplmode;
unsigned char a;
{
	return aplmode ? aplmap[a] : unixtoav(a);
}

#if	defined(WATCOM)

// Watcom does not fill in st_dev and st_ino with stuff useful to prove files
// different

static void dev_inode(struct stat *s, dev_t *device, ino_t *inode)
	{
	if(0xff != s->st_dev || 0xff != s->st_ino)	// console marker ?
		{
		*device = s->st_dev;
		*device ^= s->st_mode;
		*device ^= s->st_uid;
		*device ^= s->st_gid;
		*inode = s->st_size;
		*inode ^= s->st_mtime;
		}
	else
		{
		*device = 0xff;
		*inode = 0xff;
		}
	}
#else
static void dev_inode(struct stat *s, dev_t *device, ino_t *inode)
	{
	*device = s->st_dev;
	*inode  = s->st_ino;
	}
#endif//defined(WATCOM)

static unsigned match_file(struct stat *s, dev_t device, ino_t inode)
	{
	dev_t loc_dev;
	ino_t loc_inode;

	dev_inode(s, &loc_dev, &loc_inode);
	return loc_dev == device && loc_inode == inode;
	}

/*
 *	Support for input and output mapping initialisation 
 */

static int trans_file;			// fd for translate file	
static unsigned trans_size;		// size of translate file	
static ino_t trans_inode;		// inode of translate file	
static dev_t trans_dev;			// device of translate file	
int test_file;				// done up to this descriptor	
int trans_no_error_messages_please = 0;	// nfiles wants to turn them off 

void (*fname)();		// hide APLTRANS vs APLKEYS with this 
void i_fname(), o_fname(), d_fname(), s_fname();	// and these 
void avtoasc();

static unsigned char *curr_start_of_line;

#define MAXST 18	// keeps 4 byte allignment 

#define FORMFEED 12

#ifdef	INITBYTES_FUNCTION
static void initbytes(start, count, value)
register unsigned char *start;
register unsigned count;
register unsigned char value;
{
while(count--)*start++ = value;
}
#else//  
#define	initbytes(start, count, value)	memset(start, value, count)
#endif//  

unsigned char *fextend(fname, fext)
unsigned char *fname, *fext;
{
static unsigned char nullstr[] = "";
#ifdef	FEXTEND
unsigned char * slash = strrchr(fname, '/');
unsigned char * back = strrchr(fname, '\\');
unsigned char * dot = strrchr(fname, '.');
unsigned char * dir = slash > back ? slash : back;

if(dot <= dir) return fext;
#endif	// FEXTEND 
return nullstr;
}

unsigned char * ftrunc			// truncates name
	(
	unsigned char **this
,	unsigned char **lim
,	unsigned char ext[4]
,	enum {ASCII, QUADAV} charset
	)
	{
#if	defined(FEXTEND)
// normalise the slashes and truncate the extension 
	static struct
		{
		unsigned char lowera;
		unsigned char uppera;
		unsigned char slash;
		unsigned char slope;
		unsigned char point;
		} map[2] = 
		{
			{	// ASCII
			'a', 'A', '/', '\\', '.'
			}
		,	{	// QUADAV
			AL, A, SLASH, SLOPE, POINT
			}
		};
	unsigned char lower_ext[4] = ".";
	unsigned char *from, *to;
	int char_shift = map[charset].uppera - map[charset].lowera;
	unsigned char slash = map[charset].slash;
	unsigned char slope = map[charset].slope;
	static unsigned char buf[MAXFCHARS];
	unsigned i;

	for
		(
		from = ext + 4
	,	to = lower_ext + 4
	;	from > ext + 1
	;	*--to = *--from - char_shift
		);
	for
		(
		from = *this
	,	to = buf
	;	from < *lim
	;	++from
	,	++to
		)
		{
		if(slash == (*to = *from)) *to = slope;
		}
	if((i = 4) < *lim - *this) for
		(
		from -= 4
	;	i--
	&&	
			(
			from[i] == ext[i]
		||	from[i] == lower_ext[i]
			)
	;
		);
		
	if(0 == ++i) to -= 4;

	*to = 0;	// always null terminate
	*this = buf;
	*lim = to;
#endif//defined(FEXTEND)
	return *this;
	}


#if	defined(DOSWIN)
#	define PUNCTUATION	"/\\:"
#else	// defined(DOSWIN) 
#	define PUNCTUATION	"/"
#endif	// defined(DOSWIN) 

static SIGNED char pathdelim[] = { PATHDELIM, 0 };
static SIGNED char dirdelim[] = { DIRDELIM, 0 };

static void t_fname(tp, envdir, dirname, envname, ext, buf, errflag)	// develop a filename 
unsigned char *tp;		// null or target file name 
unsigned char *envdir;		// "APLTRANS" or "APLKEYS" 
unsigned char *dirname;		// "apltrans" or "aplkeys" 
unsigned char *envname;		// "APLT"     or "APLK"	   
unsigned char *ext;		// ".DOT"     or ".DIN"	   
unsigned char *buf;		// where to put the file name 
unsigned errflag;		// called by error handler 
{
unsigned char *ep, *dp;
static unsigned skip;
static ino_t inode;
static dev_t device;
unsigned char tbuf[127];	// somewhere to copy enviroment vars to 

if(!buf)
	{
	// initialise static data 
	skip = 0;		// skip no levels of APLKEYS 
	device = 0;		// set last device read to impossible 
	inode = 0;		// values 
	return;
	}
if(!tp)
	{
	ep = envname + 4;
	if(test_file>9)*ep++ = '0' + test_file/10;
	*ep++ = '0' + test_file%10;
	*ep=0;

	ep = (void *)getenv(envname);
	if(0 == ep)
		{
		if(is_user_io(test_file))
			{
			*(envname+4) = 0;	// "APLK" 
			ep = (void *)getenv(envname);
			if(0 == ep) ep = (void *)getenv("TERM");
			if(0 == ep) ep = (void *)"default";
			}
		else
			ep = (unsigned char *)"file";
		}
	tp = ep;
	}
strcpy(tbuf, tp);
tp = tbuf;
strcat(tbuf, fextend(tbuf, ext));
if(strcspn(tp, PUNCTUATION) == strlen(tp))	// relative pathname ? 
	{
	switch(0 != (dp = (void *)getenv(envdir)))
		{
		default:
			{
			struct stat sbuf;
			unsigned count;

			sbuf.st_dev = 0; // in case we dont succesfully stat 
			sbuf.st_ino = 0; // a file 
			buf[0] = 0;	 // in case APLKEYS exists but is 0
			for(count = 0 ;;skip += count++ == skip, dp += *dp != 0)
				{
				unsigned char *bp = dp;
				unsigned n;

				dp += strcspn(dp, pathdelim);
				if(bp == dp)break;
				if(count == skip)
					{
					strncpy(buf, bp, n = dp - bp);
					buf[n] = 0;
					strcat(buf,dirdelim);
					strcat(buf,tp);
					if
						(
/* got a file */				-1 != stat(buf, &sbuf)
/* is a plain file */			&&	S_IFREG == (S_IFREG & sbuf.st_mode)
					&&		(
/* is an error or */					errflag
/* different from last one read */		||	0 == match_file
								(
								&sbuf
							,	device
							,	inode
								)
							)
						)break;
					}
				}
			dev_inode(&sbuf, &device, &inode);
			}
			break;
		case 0:		// build the default 
			dp = (void *)getenv("DYALOG");
			if(0 == dp)
#if	defined(DOS)
				dp = (unsigned char *)"c:\\dyalog";
#elif defined(MAINWIN)
				dp = (unsigned char *)"/usr/mdyalog";
#elif defined (WINDOWS3)
				dp = (unsigned char *)"c:\\wdyalog";
#else	
				dp = (unsigned char *)"/usr/dyalog";
#endif	
			strcpy(buf, dp);
			strcat(buf, dirdelim);
			strcat(buf, dirname);
			strcat(buf,dirdelim);
			strcat(buf,tp);
			break;
		}
	}
else strcpy(buf, tp);
}

static int t_fopen(name, error2)
unsigned char *name;	// file name 
unsigned char *error2;	// sub error mesage 
{
struct stat statbuf;
void	eno();

if
	(
	(-1 == (trans_file = open(name, O_RDONLY | O_BINARY))) ||// cant open 
	(-1 == fstat(trans_file, &statbuf))	// no file 
	) 
	{
	if(trans_no_error_messages_please == 0)
		{
		static unsigned char error0[] = "Stream ";
		static unsigned char error1[] = ": Can't access ";
		static unsigned char last_error_name[MAXFCHARS] = "";

		if(0 == strcmp(name, last_error_name)) return -1;
		strncpy(last_error_name, name, MAXFCHARS);
		last_error_name[MAXFCHARS - 1] = 0;
#if	GUI && defined(WINDOWS3)
		{
		unsigned char buf[256];

		sprintf
			(
			buf
		,	"%s %i %s %s %s"
		,	error0
		,	test_file
		,	error1
		,	name
		,	error2
			);
		W3Error(buf);
		}
#else //GUI && defined(WINDOWS3)
		write(2, error0, strlen(error0));
		eno(test_file);
		write(2, error1, strlen(error1));
		write(2, name, strlen(name));
		write(2, error2, strlen(error2));
#endif//GUI && defined(WINDOWS3)
		}
	return -1;
	}

trans_size = statbuf.st_size;
dev_inode(&statbuf, &trans_dev, &trans_inode);

#if defined(DOSWIN)
binary_file(trans_file);
#endif

return trans_file;
}

void	(*x_error)();		// helps quadSR & nfiles avoid exiting 

	//	values passed to (*x_error)()	

#define	NULLERROR	0
#define	NUM_WOT		1
#define	NUM2BIG		2
#define	MINUS_NO_M	3
#define	UNKNOWN_LC	4
#define	FILE2BIG	5
#define	CANT_OPEN	6
#define	CANT_READ	7
#define	NOT_ASCII	8
#define	SYNTAX		9
#define	STRING2BIG	10
#define	EMBEDDED_NULL	11
#define	DUP_STRING	12
#define	NO_COLON	13
#define	PROG_MODE	14
#define	USER_MODE	15
#define	STRING2MANY	16
#define TC_CAPS		17
#define	BOTH_LOWER	18

#ifdef	INTERRUPTS
#define	WEAK2BIG	19
#define	STRONG2BIG	20
#define	WEAK_MODES	21
#define	STRONG_MODES	22
#endif	// INTERRUPTS 
#define	MALLOC_FAIL	23

static void	init_err(int code)
{
	void io_error();		// error handling routine 

	static SIGNED char *msgs[] =
			{
			"",
			"digit expected",
			"number exceeds 255",
			"non-mode line starts with '-'",
			"unrecognised line code",
			"file too big",
			"can't open",
			"can't read",
			"file not ASCII / not terminated by newline",
			"invalid syntax",
			"string exceeds 30 chars!",
			"file contains embedded nulls",
			"duplicate string",
			"colon expected",
			"invalid PROG mode",
			"invalid USER mode",
			"too many strings",
			"caps exchange value must exceed 4",
			"already specified as upper case"
#ifdef	INTERRUPTS
			,
			"weak interrupt must be one character",
			"strong interrupt must be one character",
			"weak interrupt differs across modes",
			"strong interrupt differs across modes"
#endif	// INTERRUPTS 
			,"unknown error"
			};
	unsigned maxcode = -1 + sizeof(msgs) / sizeof(msgs[0]);

	if(code > maxcode) code = maxcode;
	io_error(msgs[code]);
}

static void	quadsr_lc_err(code)
int	code;
{
	error(61);
}

/*
	Support for input mapping
	i_init()	get the keyboard map table
	inkey()		get an input keystroke
	inlab()		returns pointer to apl string
	keyset()	returns current mode and sets new mode
	v_inkey()	kludge for via - do inkey() but dont allow mode change
*/



struct Fd_map in_fd[_NFILE];		// the input maps		

/*	key logging:

	logkey: whether this task logs keys: 0 in ap's, apl's main() sets
		 flag if DEBUG_K.

*/

int		logkey = 0;		// default don't log		
static int	keylog = -1;		// opened in (recursive) i_init	
void d_error();

static void i_finish(void)
	{
	unsigned i, j;
	struct Imap *map;

	for(i = _NFILE; i--;)if (map = in_fd[i].map)
		{
		for(j = i; j--;) if(map == in_fd[j].map) in_fd[j].map = 0;
		free(map);
		}
	}

void i_init()
{
	if
		(
		logkey				// want to log		
	&&	keylog == -1				// first time through	
		)
		{
		keylog = creat( "apllog", 0666);

		if(-1 == keylog)		// couldn't open	
			logkey = 0;		// can't log		
		}

if(!x_error || x_error == d_error) x_error = init_err;
fname   = i_fname;

// while(_NFILE>++test_file) all current code uses fd = 0 
for(test_file = 0; 1 > test_file; ++test_file) switch(test_file)
	{
	case 1: case 2: // outlaw these for input 
#if	!defined(WATCOM)
	case INPIPE: case OUTPIPE:
#endif//!defined(WATCOM)
		break;;
	default:
		if(i_get(0))i_filbuf();
		break;
	}
#ifdef INTERRUPTS
// set up the weak and strong interrupts so that inittty() can install them 
if(in_fd[0].map)	// we have a keyboard 
	{
	extern unsigned char tty_weak, tty_strong; // see tty.c 

	tty_weak = in_fd[0].map->weak_int;
	tty_strong = in_fd[0].map->strong_int;
	}
#endif	// INTERRUPTS 

ReadScanMap();

atexit(i_finish);
o_init();	// get the translate tables 
}

void i_fname	// develop an input file name 
	(
	unsigned char *tp		// null or target file name 
,	unsigned char *buf		// where to put the file name 
,	unsigned errflag		// is this an error 
	)
	{
	t_fname(tp, "APLKEYS", "aplkeys", "APLK  ", ".DIN", buf, errflag);
	}

static void	prestarterr(err) // error before curr_start_of_line set 
int	err;
{
	unsigned char	formfeed = FORMFEED;

	curr_start_of_line = 1 + &formfeed;

	(*x_error)(err);
}

i_get(tp)
SIGNED char *tp;
{
struct stat statbuf;	// for testing file attributes 
unsigned char envbuf[MAXFCHARS]; // for building the name of the map file 
register int i;

// test: Is the descriptor open for read 

if(-1 == fstat(test_file, &statbuf)) return 0; // descriptor not open 

#ifdef FCNTL
	i = fcntl(test_file, F_GETFL, 0);
	if(-1 == i) return 0;		// unsuitable descriptor 

	i &= O_RDONLY | O_RDWR | O_WRONLY;
	if(i != O_RDONLY && i != O_RDWR) return 0; // not read 
#else//  
	if(0 == (statbuf.st_mode & 0444)) return 0; // not read 
			// note: cant test that it is actually read 
#endif // FCNTL 

// is there an enviroment variable for this descriptor 

(*fname)(0, 0, 0); 		// init statics for top level request 
(*fname)(tp, envbuf, 0);		// get file name into envbuf 

if(-1 == t_fopen(envbuf, "\n"))
	{
	in_fd[test_file].map = 0;
	return 0;
	}

// Have we already got this keyboard map 

for(i = -1; test_file > ++i;)
	{
	if
		(
		in_fd[i].map &&		// we have a map for fd == i 
		in_fd[i].map->header.file.inode == trans_inode &&
		in_fd[i].map->header.file.device == trans_dev
		)
		{
		in_fd[test_file] = in_fd[i];
		close(trans_file);
		return 0;	// need not read the file 
		}
	}
return 1;	// caller must read the file 
}

static unsigned char *currstr; // address for next string 
static unsigned char *currbuflim;// space for current translate table 
static unsigned char *mod_fname; // name of mod file for errors 
static unsigned i_any_get(struct Imap *t);

void i_filbuf(void)
{
void *buf = malloc(MAX_BUF);
struct Imap *t = (struct Imap *)buf;
struct Imap *new;

if(0 == buf) (*x_error)(MALLOC_FAIL);
currbuflim = (unsigned char *)buf + MAX_BUF;
initbytes(buf, MAX_BUF, 0);
t->header.file.inode = trans_inode;
t->header.file.device = trans_dev;
new = realloc(t, i_any_get(t));
assert(new == t);	// I don't expect shrinking to move area if it does then
			// we need to code for it here.
}

static void * w_align(void *ptr, void *from)
{
unsigned char *cp = ptr;
unsigned char *bp = from;
unsigned len = cp - bp;
unsigned j = len & ~3;

/*
 *	Problem to solve:
 *	Align i to 4 byte boundary measured from t which may not be
 *	4 byte aligned
 */

return bp + j + 4*(j != len);
}



#define ILLEGAL -87024	// use random number as flag for illegal 

/*	default mode change action - adopt the new mode
*/

unsigned	mc_dflt(cmode, imp, up, thismode, newmode)
unsigned char	*cmode;
struct Imap	*imp;
unsigned	up;
unsigned	thismode;
unsigned	newmode;
{
	if(!imp->mode[newmode]->istemp)
		cmode[up] = newmode;

	return newmode;
}

/*	mode change action for via - change the OTHER mode, retain current.
*/

static unsigned	mc_via(cmode, imp, up, thismode, newmode)
unsigned char	*cmode;
struct Imap	*imp;
unsigned	up;
unsigned	thismode;
unsigned	newmode;
{
	if(!imp->mode[newmode]->istemp)
		cmode[!up] = newmode;	// change THE OTHER	

	return thismode;		// retain THIS		
}

int inkey(fd, up)	// read a keystroke from file fd using currmode[up]
int fd;			// file descriptor 
int up;			// USER or PROG 
{
	return Inkey(fd, up, mc_dflt);	// default mode change action 
}

int v_inkey(fd, up)	// read a keystroke from file fd using currmode[up]
int fd;			// file descriptor 
int up;			// USER or PROG 
{
	return Inkey(fd, up, mc_via);	// use via mode change action 
}

/*	read a keystroke from file fd using currmode[up]
	handle mode changes with mc_fn.
*/

int Inkey
	(
	int fd	// file descriptor 
,	int up	// USER or PROG 
,	unsigned (*mc_fn)
		(
		unsigned char *
	,	struct Imap *
	,	unsigned
	,	unsigned
	,	unsigned
		)
	)
	{
	unsigned thismode;
	int key;
	struct Imap *imp = in_fd[fd].map;

	if(0 == imp)		// no  keyboard translate file so do our best
		{		// ANSI keyboard has no temp modes
		for
			(
		;	key = m_ansi(fd, 0)
		,	ILLEGAL == key
		;
			);
		return key;
		}

	up = up == USER;

	getperm:		// get current permanent mode	
	thismode = in_fd[fd].curr_mode[up];

	for(;;)
		{
		key = m_inkey(fd, imp->mode[thismode]);

		if(key == ILLEGAL)
			goto getperm;		// illegal key leaves temp mode 


		if(logkey)
			{
			union
				{
				short	s;
				SIGNED char	c[sizeof(short)];
				} sc;

			sc.s = key;

			write(keylog, sc.c, sizeof(short));
			fsync(keylog);
			}

		if
			(
			key <= M0		// change to specific mode	
		||	key == MC		// change to next mode in cycle	
			) 
			{
			thismode = (*mc_fn)
				(
				in_fd[fd].curr_mode
			,	imp
			,	up
			,	thismode
			,	(key <= M0)
				?	M0 - key
				:	(thismode+1) % imp->n_modes
				);
			}
		else
			{
			int subst;

			return 
				(
				imp->caps_on
			&&	key > 4
			&&	(subst = imp->caps_xchg[key])
				) ? subst : key;
			}
		}
	}

int gui_Inkey
	(
	int fd	// file descriptor 
,	int up	// USER or PROG 
,	unsigned (*mc_fn)
		(
		unsigned char *
	,	struct Imap *
	,	unsigned
	,	unsigned
	,	unsigned
		)
,	int ansi
	)
	{
	static unsigned thismode;
	register int key;
	register struct Imap *imp = in_fd[fd].map;
	static int get_mode = 1;

	if(ansi || 0 == imp)	// no  keyboard translate file so do our best
		{
		key = m_ansi(fd, 0);
		return ILLEGAL == key ? 0 : key;
		}

	up = up == USER;

	if (get_mode)
		{
		thismode = in_fd[fd].curr_mode[up];
		get_mode = 0;
		}

	for(;;)
		{
		key = m_inkey(fd, imp->mode[thismode]);

		if(key == ILLEGAL)
			{
			// illegal key leaves temp mode 
			thismode = in_fd[fd].curr_mode[up];
			return 0;
			}

		if (key == MTQUEUE)
			return key;

		if(logkey)
			{
			union
				{
				short	s;
				SIGNED char	c[sizeof(short)];
				} sc;

			sc.s = key;

			write(keylog, sc.c, sizeof(short));
			fsync(keylog);
			}

		if
			(
			key <= M0		// change to specific mode	
		||	key == MC		// change to next mode in cycle	
			) 
			{
			thismode = (*mc_fn)
				(
				in_fd[fd].curr_mode,
				imp,
				up,
				thismode,
				(key <= M0)
				?	M0 - key
				:	(thismode+1) % imp->n_modes
				);
	//		return MTQUEUE; 
			}	
		else
			{
			int subst;
			get_mode = key;

			return 
				(
				imp->caps_on
			&&	key > 4
			&&	(subst = imp->caps_xchg[key])
				) ? subst : key;
			}
		}
	}

int upper_of(int fd, int key)
{
	register struct Imap *imp = in_fd[fd].map;

	return
		(
		   imp		// there is a keyboard translate 
		&& key > 4	// sensible key to translate 
		&& BIT_READ(imp->is_lower, key)	// specified as lower case 
		) ? imp->caps_xchg[key] : key;
}

int lower_of(int fd, int key)
{
	register struct Imap *imp = in_fd[fd].map;
	int subst;

	return
		(
		   imp		// there is a keyboard translate 
		&& key > 4	// sensible key to translate 
		&& ( subst = imp->caps_xchg[key] ) // something there 
		&& BIT_READ(imp->is_lower, subst) // target is lower case 
		) ? subst : key;
}

void set_key_caps_lock(int flag)
{
	struct Imap *mp = in_fd[0].map;

	if(mp) mp->caps_on = flag;
}

extern int timed_read();
int (*readfn)() = timed_read;	// allow substitution by nfiles 

#ifdef	XAPL
int	XAPLmouse_event;
#endif	// XAPL 

static int m_inkey(int fd, struct Mmap *mp)	// read a moded keystroke 
{
register int k, v;
register unsigned char *candp;	// candidate pointer 
register unsigned char *rp;	// row pointer 
register short candres;			// candidate result 
register unsigned stripped = mp->doistrip;
register unsigned timed_out = 0;

static unsigned char fifo[32]; // space for when we have read too many chars 
static unsigned char *fifo_ptr = fifo;


#ifdef	XAPL
XAPLmouse_event = 0;	// X_timed_read can send back mouse events 
#endif	// XAPL 

k = *fifo_ptr++;
if(!k)	// no unsigned char in buffer 
	{
	*(fifo_ptr = fifo) = 0;	// buffer is empty 
	k = (*readfn)(fd, 1);
	switch(k)
		{
	case -3:
		return WI;	// interrupted 
	case -1:
		*fifo_ptr++ = k;
		*fifo_ptr = 0;
		return 0;
	case MTQUEUE:
		return k;
	default:
		if(k < 0)
			{
			// I would like to test for M0 - nmodes, but I don't
			// have that value within the moded structure.
			// The test is necessary because of a dodgy HP
			// intellimouse driver that does strange things with
			// WM_MOUSEWHEEL
			if(k < M0 - 255) goto ret_illegal;
			return k;
			}
		*fifo_ptr++ = k;
		*fifo_ptr = 0;
		break;
		}
	}
#ifdef	XAPL
if (XAPLmouse_event) return k;		// already a code	
#endif	// XAPL 
k &= stripped ? 0x7f : 0xff;
	
v=mp->char_or_index[k];

if(BIT_READ(mp->direct, k))
	{
	if (v) return v;	// normal exit 
	goto ret_illegal;
	}

rp = mp->strs + v*mp->cols;

if(*rp != k) goto ret_illegal;	// no entries at all for this first unsigned char 

// special case single character special keys 

if(!rp[1])
	return mp->result[v];

if(--fifo_ptr != fifo) // copy it down  ?
	{
	/*
	 * consider the following hypothetical situation - map expects 
	 * key to send abc, key actually sends abd, a key which sends da is
	 * defined - user continually hits key which sends abd
	 */
	unsigned char *fp = fifo;
	
	do *fp++ = *fifo_ptr; while (0 != *fifo_ptr++);
	fifo_ptr = fifo;
	}

candp = rp; rp += mp->cols;
candres = mp->result[v++];

timed_out = 0;
				
for(;;)
	{
	unsigned char f = *fifo_ptr;

	if(stripped) f &= 0x7f;
	switch(((*candp != 0) << 1 ) | (f != 0))
		{
		case 0:
			// perfect match 
			*(fifo_ptr = fifo) = 0; // throw the buffer away 
			return candres;
		case 1:
			// matched but the buffer is not empty 
#ifndef	APOLLO
			if(fifo[0] == 27 && mp->isatty)break;
#endif	// APOLLO 
			return candres;
		case 2:
			// no more characters in the buffer 
			if(!timed_out)
				{
				int tr_val = (*readfn)(fd, 0);

				switch(tr_val)
					{
				case -3:
					*fifo_ptr = 0;
					fifo_ptr = fifo;
					return WI;	// interrupt 
#if	GUI && defined(WINDOWS3)
				case MTQUEUE:
#endif//GUI && defined(WINDOWS3)
				case -2:
					timed_out = 1;
					*fifo_ptr = 0;
					break;
				default:
					*fifo_ptr = tr_val;
					break;
					}

				*(fifo_ptr+1) = 0;
				continue;
				}
			/* no more characters to come so fall through to
			   definate mismatch code
			 */
		case 3:
			// characters in both 

			if(*candp == f){candp++; fifo_ptr++; continue;}
			
			// definate mismatch 

			candp = rp; rp += mp->cols;
			candres = mp->result[v++];
			fifo_ptr = fifo;
			if(*candp == k){candp++; fifo_ptr++; continue;}

			// no match possible 

			break;
		}
	break;
	}
ret_illegal:
if(!timed_out)	// wait for time out, absorb file if not tty
	while(0 <= (*readfn)(fd, 0));
*(fifo_ptr = fifo) = 0; // throw buffer away 
return ILLEGAL;
}

typedef struct
	{
	int keycode;
	int vk;
	int shift;
	} VK;

static int vkcmp(VK *a, VK *b)
	{
	if(a->vk < b->vk) return -1;
	if(a->vk > b->vk) return 1;
	if(a->shift < b->shift) return -1;
	if(a->shift > b->shift) return 1;
	return 0;
	}

static VK * vk2input(VK *key)
	{
	static unsigned first = 1;
	static VK illegal = 
		{
		ILLEGAL,	0,	0
		};
	static VK tab[] =
		{
			{ US,	0x21,	0}		// VK_PRIOR
		,	{ DS,	0x22,	0}		// VK_NEXT
		,	{ DL_,	0x23,	0}		// VK_END
		,	{ HO,	0x24,	0}		// VK_HOME
		,	{ LC,	0x25,	0}		// VK_LEFT
		,	{ UC,	0x26,	0}		// VK_UP
		,	{ RC,	0x27,	0}		// VK_RIGHT
		,	{ DC,	0x28,	0}		// VK_DOWN
		,	{ IN,	0x2d,	0}		// VK_INSERT
		,	{ PT,	0x2d,	1}		// VK_INSERT + SHFT
		,	{ CP,	0x2d,	2}		// VK_INSERT + CNTL
		,	{ DI,	0x2e,	0}		// VK_DELETE
		,	{ UCS,	0x26,	1}		// VK_UP + SHFT 
		,	{ DCS,	0x28,	1}		// VK_DOWN + SHFT 
		,	{ LCS,	0x25,	1}		// VK_LEFT + SHFT 
		,	{ RCS,	0x27,	1}		// VK_RIGHT + SHFT 
		,	{ LWS,	0x25,	3}		// VK_RIGHT + SHFT+CTL
		,	{ RWS,	0x27,	3}		// VK_RIGHT + SHFT+CTL
		,	{ LLS,	0x24,	1}		// VK_RIGHT + SHFT+CTL
		,	{ RLS,	0x23,	1}		// VK_RIGHT + SHFT+CTL
		,	{ F0 - 1, 0x70,	0}		// VK_F1
		,	{ F0 - 2, 0x71,	0}		// VK_F2
		,	{ F0 - 3, 0x72,	0}		// VK_F3
		,	{ F0 - 4, 0x73,	0}		// VK_F4
		,	{ F0 - 5, 0x74,	0}		// VK_F5
		,	{ F0 - 6, 0x75,	0}		// VK_F6
		,	{ F0 - 7, 0x76,	0}		// VK_F7
		,	{ F0 - 8, 0x77,	0}		// VK_F8
		,	{ F0 - 9, 0x78,	0}		// VK_F9
		,	{ F0 - 10, 0x79,0}		// VK_F10
		,	{ F0 - 11, 0x7a,0}		// VK_F11
		,	{ F0 - 12, 0x7b,0}		// VK_F12
		,	{ F0 - 13, 0x7c,0}		// VK_F13
		,	{ F0 - 14, 0x7d,0}		// VK_F14
		,	{ F0 - 15, 0x7e,0}		// VK_F15
		,	{ F0 - 16, 0x7f,0}		// VK_F16
		};
	static unsigned entries = sizeof(tab) / sizeof(VK);

	if(first)
		{
		qsort(tab, entries, sizeof(VK), vkcmp);
		first = 0;
		}
	key = bsearch(key, tab, entries, sizeof(VK), vkcmp);
	return key ? key : &illegal;
	}
	
static int m_ansi(int fd, struct Mmap *mp)
	{
	int ansi;
	int value;
	int shift = 0;
	extern void W3_timed_ansi(int fd, int wait, int *value, int *ansi);
	VK find;

	W3_timed_ansi(0, 1, &value, &ansi);

	if(0 > value) return value;

	for(;-1 == ansi;)
		{
		shift = value;
		W3_timed_ansi(0, 1, &value, &ansi);
		if(0 > value)	// defensive
			{
			// defend against HP intellimouse driver
			if(M0 > value) return ILLEGAL;
			return value;	
			}
		}

	if(ansi)
		{
		if(33 > ansi)
			{
			static int control_map[33] =
				{
				ILLEGAL			// 00
			,	ILLEGAL			// 01
			,	ILLEGAL			// 02
			,	CP			// 03
			,	ILLEGAL			// 04
			,	ILLEGAL			// 05
			,	ILLEGAL			// 06
			,	ILLEGAL			// 07
			,	DB			// 08
			,	TB			// 09
			,	ILLEGAL			// 10
			,	ILLEGAL			// 11
			,	ILLEGAL			// 12
			,	ER			// 13
			,	ILLEGAL			// 14
			,	ILLEGAL			// 15
			,	ILLEGAL			// 16
			,	ILLEGAL			// 17
			,	ILLEGAL			// 18
			,	ILLEGAL			// 19
			,	ILLEGAL			// 20
			,	ILLEGAL			// 21
			,	PT			// 22
			,	ILLEGAL			// 23
			,	CT			// 24
			,	ILLEGAL			// 25
			,	ILLEGAL			// 26
			,	EP			// 27
			,	ILLEGAL			// 28
			,	ILLEGAL			// 29
			,	ILLEGAL			// 30
			,	ILLEGAL			// 31
			,	DP			// 32
				};

			return control_map[ansi];
			}
		else			// normal character
			{
			unsigned char c = ansi;

			ansi2av(&c, 1);
			return c;
			}
		}
	find.vk = value;
	find.shift = shift;
	return vk2input(&find)->keycode;
	}

unsigned char *inlab(fd, name)
int fd;
register SIGNED char *name;
{
	struct Imap *mp = in_fd[fd].map;
	register unsigned char *lab = "";
	
	if(mp)lab = mp->labinfo;

	while('\0' != *lab)			// not labinfo terminator 
		{
		if(strcmp(lab, name))
			{
			lab += 1+strlen(lab);	// skip wrong name	  
			lab += 1+strlen(lab);	// skip its label	  
			}
		else
			{
			lab += 1+strlen(lab);	// skip right name	  
			return lab;		// return its label	  
			}
		}

	return lab;				// pointer to empty string 
}

	// return current programmer mode and set new mode 
unsigned keyset(fd, new, up)
int fd;		// file descriptor 
unsigned new;	// new mode 
int up;		// USER or PROG 
{
int old;

up = up == USER;
old = in_fd[fd].curr_mode[up];
in_fd[fd].curr_mode[up] = new;
return old;
}



static struct Out_fd	*out;		// relevent output structure 
int	(*out_fn)();	// output function to use GLOBAL for prt.c 
int	(*out_fail)();	// what to do on failure global for prt.c 
static unsigned char 	state;		// current state 
static unsigned char	used;		// anything gone out for ... 

unsigned out_fld;	// output file descriptor global for sm.c 
FILE	 *out_sd;	// output stream (if used)global for nfiles.c 

static	struct Out_fd out_fd[_NFILE];
	struct Out_fd *o_out[_NFILE];	// one for each file descriptor 

static struct Out_fd raw_fd;		// forward reference - this file


void	(*o_fn)();	// communication function 

unsigned char   fbt_buff[4096];	// was 256 but multi screens will be bigger
unsigned char * fbt_buffptr;

int fbt_out_buf(char * cp, unsigned count)
{
	// imbedded carriage ^s may be a problem 

	unsigned ret = count;
	for(;count--;)*fbt_buffptr++ = *cp++;
	return ret;
}

static unsigned char *wincharsptr;

static int WINCHARS_out(char *cp, unsigned count)
	{
	unsigned ret = count;

	if(count) *wincharsptr = *cp; // only take one character - translate
	return ret;			// should be 1 to 1 mapping
	}

static unsigned char *colorptr;

static int COLOR_out(UCHAR *cp, unsigned count)
	{
	unsigned ret = count;
	
	if(count > 3) count = 3;	// defensive
	for(;count--;)*colorptr++ = *cp++;
	return ret;
	}


static void cache_tab(void)	// cache the translate table    
	{
#if	GUI && defined(WINDOWS3)
	void special();
	unsigned i;

	out = o_out[1];
	if(0 == out || 0 == is_user_io(1))
		{
		out = o_out[2];
		if(0 == out || 0 == is_user_io(2)) out = &raw_fd;
		}
	cached = 1;
	out_fn = COLOR_out;
	for(i = 256; i--;)
		{
		colorptr = &FOREGROUND[i][0]; special(C0);
		colorptr = &FOREGROUND[i][0]; special(C0 - i);
		colorptr = &BACKGROUND[i][0]; special(B0);
		colorptr = &BACKGROUND[i][0]; special(B0 - i);
		}
	out_fn = WINCHARS_out;
	for(i = 256; i--;)
		{
		wincharsptr = &WINCHARS[i]; avtoasc(i);
		BODGECHARS[WINCHARS[i]] = i;
		}
	BODGECHARS[WINCHARS[SQUISH]] = SQUISH; // special case this one 
#endif//GUI && defined(WINDOWS3)
	}


void o_fname	// develop an output file name 
	(
	unsigned char *tp		// null or target file name 
,	unsigned char *buf		// where to put the file name 
,	unsigned errflag		// an error condition ? 
	)
	{
	t_fname(tp, "APLTRANS", "apltrans", "APLT  ", ".DOT", buf, errflag);
	}

void o_finish(void);

void o_init(void)
{
/*
 *	allocate necessary translate tables at run time (malloced)
 *	if d_init() is used instead of o_init() then a date map
 *	and a keyboard map are installed as well.
 *	if i_init() is used instead of o_init() then keyboard map
 *	is installed as well.
 */

if(!x_error || x_error == d_error) x_error = init_err;
fname   = o_fname;

for(test_file = 0; _NFILE > test_file; ++test_file) switch(test_file)
	{
	case 0:		// outlaw using 0 for output 
#if	!defined(WATCOM)
	case INPIPE: case OUTPIPE:
#endif//!defined(WATCOM)
		break;
	default:
		if(o_get(0)) o_filbuf();
		break;
	}
cache_tab();
atexit(o_finish);
}


static unsigned o_any_get(struct Translate *t);

void o_filbuf(void)
{
unsigned char *buf = malloc(MAX_BUF);
struct Translate *t = (struct Translate *)buf;
struct Translate *new;

if(0 == buf) (*x_error)(MALLOC_FAIL);
currbuflim = (unsigned char *)buf + MAX_BUF;
initbytes(buf, MAX_BUF, 0);
t->inode = trans_inode;
t->device = trans_dev;
new = realloc(t, o_any_get(t));
assert(new == t);		// else shrinking moved it
}


static void t_abort()
{
(*x_error)(FILE2BIG);
}

int o_get(tp)
SIGNED char *tp;
{
struct stat statbuf;
unsigned char  envbuf[MAXFCHARS];
int i;
struct Out_fd *this;

// test is the descriptor open for write 

if(-1 == fstat(test_file,&statbuf)) return 0;	// descriptor not open 
#if	defined(WATCOM)
	if(is_user_io(test_file))
		{
		statbuf.st_dev = 0xff;	// marker for console 
		statbuf.st_ino = 0xff;	// marker for console 
		}
#endif	// defined(WATCOM) 

#ifdef	FCNTL
i = fcntl(test_file, F_GETFL, 0);
if(-1 == i) return 0;			// unsuitable descriptor 

i &= O_RDONLY | O_RDWR | O_WRONLY;
if(i != O_RDWR && i != O_WRONLY) return 0; // not write 

#else//  
if(0 == (statbuf.st_mode & 0666)) return 0;    // not write 
		// cant test that it is actually write 
#endif	// FCNTL 

// do we already know about this device 

for(i= -1;test_file> ++i;)
	{
	if
		(
		o_out[i]
	&&	match_file(&statbuf, o_out[i]->out_dev, o_out[i]->out_ino)
		)
		{
		o_out[test_file] = o_out[i];	// already know it 
		return 0;
		}
	}

// initialise an output struct 

this = o_out[test_file] = &out_fd[test_file];
dev_inode(&statbuf, &this->out_dev, &this->out_ino);
this->curr_col = 0;

o_fname(0, 0, 0);		// init statics for top level request 
o_fname(tp, envbuf, 0);	// put file name to read in envbuf 

if(-1 == t_fopen(envbuf, "\n"))
	{
	o_out[test_file] = &raw_fd;
	return 0;
	}
	// prestarterr(CANT_OPEN);

// do we already know about this translate table 

for(i= -1;test_file > ++i;)
	{
	if
		(
		o_out[i] &&
		o_out[i]->t_out->inode == trans_inode &&
		o_out[i]->t_out->device == trans_dev
		)
		{
		o_out[test_file]->t_out = o_out[i]->t_out;
		close(trans_file);
		return 0;
		}
	}

// we need to read the file 

return 1;
}

void o_finish(void)
{
/* put all files into known state for exit -
 * use RESET: string
 */
unsigned i, j;
void special();
	
for(i=_NFILE;i--;)if(out = o_out[i])
	{
	if(out->out_used)
		{
		int out_raw();

		out_fld = i;
		out_fn = out_raw;
		out_fail = 0;
		special(RESET);
		}
	for(j=i;j--;)if(o_out[j] == out)
		{
		o_out[j] = 0;
		}
	if(out != &raw_fd)
		{
		free(out->t_out);
		}
	}
}

static void eno(n)	// print n 
unsigned n;
{
unsigned char c;
if(n>=10)eno(n/10);
c = '0' + n%10;
write(2, &c, 1);
}

int err_eq_out()
{
	/*
	 * is device connected to file descriptor 2 the same device
	 * as that connected to file descriptor 1
	 */
return o_out[1]==o_out[2];
}


init_out(describe, fail)
register unsigned describe;
register int (*fail)();
{
register unsigned fd;	// the file descriptor 

if(describe>_NFILE)	// stream 
	{
	FILE *stream = (FILE *)describe;
	int out_stream();

/* make output exactly match the output translate i.e.
	if we put out 13 10 we do not want DOS to make it
	13 13 10
*/
#if !defined(MAINWIN)
	binary_stream(stream);
#endif
	fd = fileno(stream);
	out_sd = stream;
	out_fn = out_stream;
	}
else
	{		// file descriptor 
	int out_raw();

	fd = describe;
	out_fn = out_raw;
	}
if(out = o_out[fd])
	{
#ifdef	DOS
		{
		extern unsigned iam_dos_console;
		extern int dos_out();

		if(!out->out_used)	// first time 
			out->is_dos_console = is_user_io(fd);
		if(iam_dos_console = out->is_dos_console) out_fn = dos_out;
		}
#endif	// DOS 
#ifdef	XAPL
		{
		extern unsigned iam_X_console;
		extern int X_out();
		extern int isanX();
		extern void loadXcolours();

		if(!out->unused)	// don't know yet if an X console 
			out->unused = isanX(fd);
		if(iam_X_console = out->unused) out_fn = X_out;
		if(iam_X_console) loadXcolours(out);
		}
#endif	// XAPL 
#if	GUI && defined(WINDOWS3)
		{
		extern int WIN_out();

		if(is_user_io(fd))out_fn = WIN_out;
		}
#endif//GUI && defined(WINDOWS3)
	out->out_used = 1;	// flag this fd as used for o_finish() 
	out_fld = fd;
	out_fail = fail;
	special(INIT);
	state = 0;	// set to first 
	used  = 0;	// set to unused  
	return 0;
	}
else 
	{
	(*fail)();
	return -1;
	}
}

#ifdef	DOS
static int inrange(int from, int to, int value)
{
	return (value >= from) && (value <= to);
}
#endif//DOS 

int fastupdate(new, old)
long *new;
long *old;
{
#ifdef	DOS

if(out->is_dos_console)
	{
	struct Translate *t = out->t_out;
	static unsigned char first = 1;
	typedef unsigned short SARRAY[256];
	static SARRAY v, f, b;
	static unsigned char c[256];
	
	if(first)
		{
		struct Sas *s = t->special;
		unsigned n = t->nsas;
		unsigned av_out();

		--s;
		while(n--)
			{
			int code = (++s)->code;

			if(inrange(V0-255, V0, code))
				*(v+V0-code) = *(unsigned short *)(t->strstart+s->offset);
			else if(inrange(B0-255, B0, code))
				*(b+B0-code) = *(unsigned short *)(t->strstart+s->offset);
			else if(inrange(C0-255, C0, code))
				*(f+C0-code) = *(unsigned short *)(t->strstart+s->offset);
			}
		for(n=256;n--;)
			{
			unsigned char *tp = c+n;

			switch(av_out(t, n, &tp))
				{
			case 1: break;
			case 0: if(2 > av_out(t, 0, &tp)) break;
			default:if(out_fail)(*out_fail)();
				}
			}
/* 
 * CLUDGE - adam wants to use position 0 as a screen null - I will show it as
 * space - this clobbers anyone who wants to use QuadAV[0] for a genuine 
 * character
 */
		c[0] = c[4];
		first = 0;
		}
	return dos_fastupdate(new, old, c, v, f, b);
	}

#endif	// DOS 

return 0;	// not updated 

}

#ifdef	DOS
void set_out_fn(int (*fn)())	// DOS full scr needs this 
{
out_fn = fn;
}
#endif	// DOS 

void special(code)
int code;
{
register struct Translate *t = out->t_out;
register struct Sas *s = t->special;
register unsigned n = t->nsas;
register unsigned count;

if(!n) return;			// no strings 
if(code == INIT && s->code != INIT)return; // special case no INIT string 
for(;n--; s++)
	{
	if(s->code == code)
		{
		count = s->len;
		if(!count) return;
		(*out_fn)(t->strstart + s->offset, count);
		return;
		}
	}
return;
}

static int out_stream(cp, count)
register unsigned char *cp;
register unsigned count;
{
register int sent = fwrite(cp, 1, count, out_sd);

if(sent != count && out_fail)(*out_fail)();
return sent;
}

static int out_raw(cp, count)
register unsigned char *cp;
register unsigned count;
{
register int sent = write(out_fld, cp, count);

if(sent != count && out_fail)(*out_fail)();
return sent;
}

static int g_count;	// communication from out_count() to t_count() 

static int out_count(cp, count)
unsigned char *cp;
unsigned count;
{
return g_count = count;
}

int t_count(fn, p1, p2, p3)
void (*fn)();			// function to measure ascsp() or avtoasc() 
int p1, p2, p3;			// parameters to pass it 
{
int (*save)() = out_fn;		// shadow out_fn 

g_count = 0;			// in case (*out_fn)() not called 
out_fn = out_count;		// lie about output function 
(*fn)(p1, p2, p3);		// call the requested function 
out_fn = save;			// unshadow 
return g_count;
}

/*
 * functions / globals to help nfiles go faster 
 */

unsigned char t_is_safe;
unsigned char t_safe_code;

void t_safe_init_out(fd)
{
	// cut down init_out() - I dont want to call SPECIAL() 
	out = o_out[fd];
	state = 0;
	used = 0;
}

int t_safe(cp, count)
unsigned char *cp;
unsigned count;
{
	t_is_safe = 1 == count && 1 == out->t_out->nmodes;
	t_safe_code = *cp;
	return count;
}

static unsigned char *buf_ptr;	// comm from X_buffer() to t_buffer() 

static int X_buffer(cp, count)
unsigned char *cp;
unsigned count;
{
buf_ptr = cp;
return count;
}

unsigned char *t_buffer(fn, p1, p2, p3)
void (*fn)();			// function to measure special() 
int p1, p2, p3;			// parameters to pass it 
{
int (*save)() = out_fn;		// shadow out_fn 

buf_ptr = (unsigned char *)0;	// in case (*out_fn)() not called 
out_fn = X_buffer;		// lie about output function 
(*fn)(p1, p2, p3);		// call the requested function 
out_fn = save;			// unshadow 
return buf_ptr;
}

static unsigned av_out(t, row, bufpt)
register struct Translate *t;
register unsigned row;
register unsigned char **bufpt;
{
register short unsigned sum, n;
register unsigned char *rp = t->lengths + row*t->nmodes;

sum = 0;
if(state)for(n = 0; n++ < state; ) sum += *(rp++);
n = *rp;
rp = t->strstart + t->offset[row] + sum;
switch(n)
	{
case 1:
	**bufpt = *rp;
	break;
default:
	memcpy(*bufpt, rp, n);
	break;
	}
*bufpt += n;
return n;
}

void avtoasc(c)
unsigned char c;
{
register struct Translate *t = out->t_out;	// translate table 
unsigned char buf[32];				// output buffer 
unsigned char *cp = buf;

#ifdef	DOS
if(out_fn == dos_out) switch(c)
	{
case 1: case 2: case 3:		// cursor control character 
	dos_out(&c, -c);
	return;
	}
#endif	// DOS 
#ifdef	XAPL
if(X_out == out_fn)switch(c)
	{
case 1: case 2: case 3:	// cursor control character 
	X_out(&c, -c);
	return;
	}
#endif // XAPL 
#if	GUI && defined(WINDOWS3)
if(WIN_out == out_fn)switch(c)
	{
case 1: case 2: case 3:	// cursor control character 
	WIN_out(&c, -c);
	return;
	}
#endif//GUI && defined(WINDOWS3)
if(!av_out(t, c, &cp)) // cant go out in current mode 
	{
	register unsigned char *lp = t->lengths + c*t->nmodes;
	register unsigned n;

	for(n = 0; n < t->nmodes; n++, lp++)
		{
		/*
		 * note that
		 * offset[c] is the start of the output string
		 * ( all previous counts are 0 ).
		 * This code does not use this fact.
		 */
		if(*lp)	// will go out in mode n 
			{
			// change to mode n from mode state 
			av_out(t, MODE0+n, &cp);
			state = n;
			// now output the character 
			av_out(t, c, &cp);
			break;
			}
		}
	if(cp == buf)	// still failed to find a character 
		{
		if(c)
			{
			avtoasc(0);	// print character 0 instead 
			return;
			}
		// else put out nothing but still worry about backspace etc 
		}
	}

(*out_fn)(buf, cp-buf);

used = 1;

switch(c)	// try to cope with cursor movement characters in quadav 
	{
	default:
		out->curr_col++;	break;
	case BS:	// backspace 
		if(out->curr_col) out->curr_col--; break;
	case LF:	// line feed 
		// character output above should have been newline 

		{
		register unsigned i;

		for(i=out->curr_col; i--;) avtoasc(SP); break;
		}
	case NEWLINE:
		out->curr_col = 0; break;
	}
}


ascsp()
/*
 * ensure a blank on screen in case screen supports an overstrike
 * which we dont recognise
 */
{
register struct Translate *t = out->t_out;	// translate table 
unsigned char buf[32];				// output buffer 
unsigned char *cp = buf;
unsigned char *tp;

tp = cp;
if(!av_out(t, CC, &cp)) // cant go out in current mode 
	{
	register unsigned char *lp = t->lengths + CC*t->nmodes;
	register unsigned n;

	for(n = 0; n < t->nmodes; n++, lp++)
		{
		if(*lp)	// will go out in mode n 
			{
			// change to mode n from mode state 
			av_out(t, MODE0+n, &cp);
			state = n;
			// now output the character 
			av_out(t, CC, &cp);
			break;
			}
		}
	}
if(cp == tp)return;	// abort if cant be done 
(*out_fn)(buf, cp-buf);
used = 1;
}

#if	GUI && defined(WINDOWS3)
unsigned char avtoWasc(unsigned char c)
/* obtain output character corresponding to quadAV character 'c'
 * for Windows3 implementation
 */
{
register struct Translate *t = out->t_out;	// translate table 
unsigned char buf[32];				// output buffer 
unsigned char *cp = buf;
		
if(!av_out(t, c, &cp)) // cant go out in current mode 
	{
	register unsigned char *lp = t->lengths + c*t->nmodes;
	register unsigned n;

	for(n = 0; n < t->nmodes; n++, lp++)
		{
		if(*lp)	// will go out in mode n 
			{
			// change to mode n from mode state 
			av_out(t, MODE0+n, &cp);
			state = n;
			// now output the character 
			av_out(t, c, &cp);
			break;
			}
		}
	}
if(cp == buf)	// still failed to find a character 
	if(c)
		return 0;

return buf[0];		// I know it's only one character for quadAV  
}

#else //GUI && defined(WINDOWS3)

unsigned char avtoWasc(unsigned char c) { syserror(300); return 0; }

#endif//GUI && defined(WINDOWS3)

#if	defined(XAPL)
unsigned char avtoXasc(c)
unsigned char c;
/* obtain output character corresponding to quadAV character 'c'
 * for X Window implementation
 */
{
register struct Translate *t = out->t_out;	// translate table 
unsigned char buf[32];				// output buffer 
unsigned char *cp = buf;
		
if(!av_out(t, c, &cp)) // cant go out in current mode 
	{
	register unsigned char *lp = t->lengths + c*t->nmodes;
	register unsigned n;

	for(n = 0; n < t->nmodes; n++, lp++)
		{
		if(*lp)	// will go out in mode n 
			{
			// change to mode n from mode state 
			av_out(t, MODE0+n, &cp);
			state = n;
			// now output the character 
			av_out(t, c, &cp);
			break;
			}
		}
	}
if(cp == buf)	// still failed to find a character 
	if(c)
		return 0;

return buf[0];		// I know it's only one character for quadAV  
}

#endif//defined(XAPL)


	/*
	 *	GENERAL ROUTINES FOR INPUT, OUTPUT AND DATE FILE INTERPRETERS
	 */

#define	IOD_DECLARE(name)	static unsigned char	*name(cp, ep) \
				register unsigned char	*cp, *ep;

IOD_DECLARE(white)
{
while(*cp == ' ' || *cp == '\t' || *cp == '\r')cp++;
return cp;
}

IOD_DECLARE(comment)
{
if(cp == ep || *cp == '+')return ep;
(*x_error)(SYNTAX);
return 0; 	// keep compiler happy 
}

static unsigned lastnumber;	// for number() to communicate 

IOD_DECLARE(number)
{
unsigned char *wp = cp;
unsigned n = 0;

while(i_digit(*cp)) { n *= 10; n += *cp++ - '0';}
if(wp == cp)(*x_error)(NUM_WOT);
if(n > 255) (*x_error)(NUM2BIG);
lastnumber = n;
return cp;
}

IOD_DECLARE(colon)
{
cp = white(cp, ep);
if(*cp != ':')(*x_error)(NO_COLON);
cp++;
cp = white(cp, ep);
return cp;
}

static unsigned mod_flen;

IOD_DECLARE(modifies_desc)
{

if(memcmp(cp, "MOD", 3)) return cp;
cp += 3;
cp = colon(cp, ep);
mod_fname = cp;
for(;;)
	{
	switch(*cp)
		{
		default:
			cp++;
			continue;
		case ' ': case '\t': case '\n': case '+':
			mod_flen = cp - mod_fname;
			break;
		}
	break;
	}

cp = white(cp, ep);
return comment(cp, ep);
}

IOD_DECLARE(mod_line)
{
unsigned char *wp = cp;

for(;;)
	{
	wp = white(wp, ep);
	switch(*wp)
		{
		case '+':
			while(*++wp != '\n');
		case '\n':
			curr_start_of_line = ++wp;
			continue;
		default:
			break;
		}
	break;
	}

if(0 != memcmp(wp, "MOD", 3))
	return cp;	// first non - comment is not MOD 
wp = colon(wp + 3, ep);
mod_fname = wp;
while(wp < ep)
	{
	switch(*wp)
		{
		default:
			wp++;
			continue;
		case ' ': case '\t': case '+': case '\n': case '\r':
			break;
		}
	break;
	}
mod_flen = wp - mod_fname;
return mod_fname;
}

static unsigned char	*line(t, cp, ep, lline_fn)
void	*t;
register unsigned char	*cp, *ep;
unsigned char	*(*lline_fn)();
{
register unsigned char *wp;
/*
 * N.B. This code needs to know it is going backwards 
 */
ep--;
for(;;)
	{
	if(*ep == FORMFEED)ep--;
	wp = ep;
	wp--;
	while(wp >= cp)
		{
		switch(*wp)
			{
			default: wp--; continue;
			case '\n': case FORMFEED: curr_start_of_line = ++wp;
			}
		break;
		}
	wp = white(wp, ep);
	if(wp != ep)(*lline_fn)(t, wp, ep);
	ep = curr_start_of_line - 1;
	if(ep <= cp)break;
	}
return cp;
}


static unsigned	setnmodes(cp, ep)	// common part of {io}_setnmodes 
register unsigned char	*cp, *ep;
{
register unsigned to_date = 0;
register unsigned thisline = 0;
register unsigned counting = 1;

while(cp < ep)switch(*cp++)
	{
	case '+': counting = 0; break;
	case '\n':
		if(thisline > to_date)to_date = thisline;
		counting = 1;
		thisline = 0;
		break;
	case ':':
		if(counting) thisline = 0;	// consider ,ER: 13 10 * + ,: 
		break;
	case ',': thisline += counting; break;
	}

	return to_date + 1;
}


	/*
	 *	INPUT MAP INTERPRETER
	 */


#define RHOQUADAV	256
#define COMMAND_BASE	-4096
static int base = COMMAND_BASE;
#define GOT_IT(i)		BIT_READ(got_it, (i) - base)
#define ISDIRECT(m, i)		BIT_READ((m)->direct, i)

#define I_DECLARE(name) static unsigned char *name(t, cp, ep)	\
			struct Imap *t;				\
			register unsigned char *cp, *ep;
/*
 B.N.F.
	<line>		::=<white><lline><newline>
	<lline>		::=,<statement>|
			   <statement>|
			   <nmodes desc>|
			   <modifies desc>|
			   <prog desc>|
			   <user desc>|
			   <label desc>|
			   <comment>

	<comment>	::=<null>|+<any non vertical spacing>

	<statement>	::=<header><colon><str def><white><comment>
	<white>		::=<null>|<white delim>|<white>
	<white delim>	::=<space>|<tab>|<cr>
	<header>	::=<header id><white><label>
	<header id>	::=-<white>M<number>|
			   M<number>|
			   F<number>|
			   <line code>|
			   <number><caps lock>
	<str def>	::=<strands>|<strands>*
	<strands>	::=<strand>|<strand><white>,<strands>
	<strand>	::=<white>|
			   <white><number>|
			   <white><number><white delim><white><strand>
	<number>	::=0|1|...|255
	<colon>		::=<white>:<white>
	<caps_lock>	::=<null>|<white>-<white><number>
	<label>		::=<null>|=<ascii string>
	<ascii string>	::=<null>|<ascii char><ascii string>
	<ascii char>	::=<alphabetic>|<symbolic>|<digit>|<space>

	<modifies desc>	::=MOD<colon><filename><white><comment>
	<filename>	::=<fullpathname>|<aplkeys relative pathname>

	<label desc>	::=L<number><colon><ascii string><white><comment>
	<prog desc>	::=PROG<colon><number><white><comment>
	<user desc>	::=USER<colon><number><white><comment>
	<line code>	::=
				WI|SI|QT|ER|TB|BT|EP|
				UC|DC|RC|LC|
				US|DS|RS|LS|
				UL|DL|LL|RL|
				HO|CT|PT|
				IN|II|DI|DP|DB|RD|
				TG|DK|OP|CP|MV|
				FD|BK|BP|
				ZM|
				SC|RP|NX|PV|RT|RA
				ED|TC|
				NB|NS|ST|EN|IF|
				HK|FX|LN|
				MC|MR|JP|
				HT|TH|
if XAPL, also			D1|D2|D3|D4|D5|U1|U2|U3|U4|U5|
if GUI also			Ll|Rl|LW|RW|Lw|Rw|Ul|Dl

	not expanded
		<fullpathname>
		<aplkeys relative pathname>
		<null>
		<any non vertical spacing>
		<space>
		<tab>
		<digit>		N.B. 0-9
		<cr>		N.B. not newline
		<alphabetic>	N.B. a-z A-Z
		<symbolic>	N.B. -=`[];'\,./!@#$%^&*()_+~{}"|<>? and space
			i.e. 7-bit ASCII printable less alphanumerics & ':'
 */

unsigned char *i_header();	// see BNF 
unsigned char *i_header_id();	// see BNF 
unsigned char *i_index();	// fix up the char_or_index array 
unsigned char *i_label();	// see BNF 
unsigned char *i_label_desc();	// see BNF 
unsigned char *i_lline();	// see BNF 
unsigned char *i_prog_desc();	// see BNF 
unsigned char *i_setnmodes();	// find how many modes have been used	
unsigned char *i_statement();	// see BNF 
unsigned char *i_str_def();	// see BNF 
unsigned char *i_strand();	// see BNF this does the difficult bit 
unsigned char *i_user_desc();	// see BNF 
unsigned char *i_caps_lock();	// see BNF 
unsigned char *mod_line();	// find line which causes another file read 

int		 getlinecode();	// quadSR calls this for str2num 
unsigned char	*lc_num2str();	// quadSR calls this for num2str 
static int	 lc_str2num();	// quadSR && i_header call this	 

void copy_up();		// memory copy utility - works backwards 
void	up_rows(),
	up_cols();	// utilities to modify size of strs matrix in Mmap 

static unsigned curr_mode;
static int curr_res;
// static unsigned char *currbuflim;	in trans.c 
// static unsigned char *mod_fname;	in trans.c 
static unsigned char *got_it;	// global pointer to local array 
				/* flags to ensure that the latest version
				 * is kept rather than using a modified 
				 * version
				 */
static unsigned lab_len;	// total space required for label info	 
static unsigned get_labs;	// are we filling in labels ? 
static unsigned get_mod_files;	// are we getting MOD files vs compiling 

static void up_cols(t, mode, count)
struct Imap *t;
struct Mmap *mode;
unsigned count;
{
// increase the number of columns in the strings matrix by count 
/*

	check  for buffer overrun here ---------------------------------+
									|
									v
	-----------------------------------------------------------------
	|strs			|result					|
	-----------------------------------------------------------------
		^		^
		|		|
		|		|
		|		+ preserve alignment here
		|
		+ insert count new bytes at row boundaries

	-----------------------------------------------------------------
	|	region 0	| region 1				|
	-----------------------------------------------------------------

region 0:
	each row moves count*row bytes
region 1:
	moves count*rows + align to short
 */

register unsigned r = mode->rows;
register unsigned c = mode->cols;
register unsigned char *addr;
register unsigned move;
register unsigned move_with_align;

addr = (unsigned char *)&mode->result[r];

move = r * count;
move_with_align = (unsigned)w_align((mode->strs + r*(c + count)), t) - (unsigned)mode->result;

if(addr + move_with_align >= currbuflim)t_abort();

copy_up(addr + move_with_align, addr, r*sizeof(short));

mode->result = (short *)((unsigned char *)mode->result + move_with_align);

addr = mode->strs + r*mode->cols;

for(; move -= count, r--; addr -= c)copy_up(addr + move, addr, c);
mode->cols += count;
}

static void up_rows(t,mode, offset)
struct Imap *t;
struct Mmap *mode;
unsigned offset;
{
/*
 * increase the number of rows in the strings matrix by 1; inserting the
 * new one before the offset one
 *
 */


/*
 * we need to create a space in mode->result for the new row
 * we need to ensure the alignment of mode->result[]
 * we need to move all rows in strs with offsets >= offset by mode->cols
 * we need to update mode->rows and mode->result
 */

/*

	check  for buffer overrun here ---------------------------------+
									|
									v
	-----------------------------------------------------------------
	|strs			|result					|
	-----------------------------------------------------------------
		^		^		^
		|		|		|
		|		|		+ insert a new result here
		|		|
		|		+ preserve alignment here
		|
		+ insert a new row here

	-----------------------------------------------------------------
	|	|  region 0	| region 1	| region 2		|
	-----------------------------------------------------------------

region 0:
	moves cols
region 1:
	moves cols + align to 4 byte boundary relative to t
region 2:
	same as region 1 + sizeof(short)
 */
unsigned move[3];
unsigned char *addr[3];
unsigned size[3];

move[0] = mode->cols;
move[1] = (unsigned)w_align((mode->strs + mode->cols*(mode->rows + 1)), t) - (unsigned)mode->result;

move[2] = move[1] + sizeof(short);

addr[0] = mode->strs + mode->rows*mode->cols;
addr[1] = (unsigned char *)&mode->result[offset];
addr[2] = (unsigned char *)&mode->result[mode->rows];

size[0] = (mode->rows - offset)*mode->cols;
size[1] = offset * sizeof(short);
size[2] = (mode->rows - offset)*sizeof(short);

if(addr[2] + move[2] > currbuflim)t_abort();

copy_up(addr[2] + move[2], addr[2], size[2]);
copy_up(addr[1] + move[1], addr[1], size[1]);
copy_up(addr[0] + move[0], addr[0], size[0]);

mode->result = (short *)((unsigned char *)mode->result + move[1]);
if(0 > ++mode->rows) (*x_error)(STRING2MANY);
}

static void copy_up(to, from, n)
register unsigned char *to, *from;
register unsigned n;
{
/*
 * straight forward copy routine that performs its operation backwards
 * rather that forwards
 * N.B.
 * The addresses given are 1 byte higher than the address to be moved
 * Thus if the object being moved is actually an array of doubles then
 * the address of the next double can be coerced and given to copy_up()
 */
if(to != from)while(n--)*--to = *--from;
}

static void TrimDosFile(unsigned char *cp)
{
#if	defined(DOSWIN)// DOS editors add rubbish to end of file 
	for(;;)
		{
		switch(cp[trans_size-1])
			{
			case 26:	// control Z 
			case ' ':
				trans_size--;
				continue;
			default:
				break;
			}
		break;
		}
#endif	// DOS 
}

unsigned char *fillmod(workbuf, ep)
unsigned char *workbuf;		// start of buffer 
unsigned char *ep;		// 1 unsigned char off the top of buffer 
{
register unsigned char *cp, *wp;
unsigned readfile = 1;

cp = ep;
get_mod_files = 1;	// affects error messages		     
while(readfile)
	{
	cp -= trans_size;
	wp = cp--;

	if(cp < workbuf)
		prestarterr(FILE2BIG);

	*cp = FORMFEED;	// mark file start points with Form Feed 
	curr_start_of_line = wp;

	if(trans_size != read(trans_file, wp, trans_size))
		(*x_error)(CANT_READ);
	close(trans_file);

	TrimDosFile(wp);

	if(cp[trans_size] != '\n')(*x_error)(NOT_ASCII);

	/*
	 * look for MOD: in area just read
	 */
	if(readfile = wp != mod_line(wp, &wp[trans_size]))	// got one ? 
		{
		unsigned char save;
		unsigned char envbuf[MAXFCHARS];

		save = mod_fname[mod_flen];
		mod_fname[mod_flen] = 0;	// put null trailing byte 
		(*fname)(mod_fname, envbuf, 0);
		mod_fname[mod_flen] = save;
		if(-1 == t_fopen(envbuf, " from "))(*x_error)(NULLERROR);
		}
	}
get_mod_files = 0;	// affects error messages		     
return cp;
}

static unsigned char workbuf[T_WKBFSZ];

static unsigned i_any_get(struct Imap *t)
{
unsigned char
	*ep = &workbuf[sizeof(workbuf)],
	*cp = ep,
	*startbuf;
unsigned char l_got_it[(RHOQUADAV - COMMAND_BASE)/ 8];
unsigned ret;

got_it = l_got_it;	// global reference for sub functions to use 

startbuf = fillmod(workbuf, &workbuf[sizeof(workbuf)]);
curr_start_of_line = startbuf + 1;
i_setnmodes(t, startbuf + 1, ep);
cp = (unsigned char * )t;
cp += sizeof(struct Imap);	// point to start of dynamic area	

get_labs = 0;			// not filling in labels		

for(curr_mode = 0; mod_fname = 0, curr_mode < t->n_modes ; curr_mode++)
	{
	struct Mmap *mp = (struct Mmap *)cp;

	t->mode[curr_mode] = mp;
	if(mp->strs >= currbuflim)t_abort();
	mp->rows = 1;
	mp->cols = 1;
	mp->result = (short *)
		(
		cp +			// start of structure 
		sizeof(struct Mmap) -	// size of fixed structure 
		4 +			// allocated dynamic size 
		2			// genuine size 
		);
	*mp->strs = 0;

	lab_len = 1;			// zap label info size count 

	// null all the got_it flags 

	initbytes(l_got_it, sizeof(l_got_it), 0);
	initbytes(mp->direct, sizeof(mp->direct), ~0);
	initbytes(mp->char_or_index, sizeof(mp->char_or_index), 0);

	mp->doistrip = 1;
	mp->istemp = 0;
	mp->isatty = is_user_io(test_file);

	cp = line(t, startbuf, ep, i_lline); // tramp the buf for this mode 

	cp = i_index(t, cp, ep);	// fix the indx bytes 

	cp = (unsigned char *)(mp->result + mp->rows);
	cp = w_align(cp, t);
	}

// now make final pass to gather labels up 

if(cp + lab_len > currbuflim)
	t_abort();

t->labinfo = cp;

get_labs = 1;			// set flag for i_label 

initbytes(l_got_it, sizeof(l_got_it), 0);

line(t, startbuf, ep, i_lline);	// go get 'em 

*t->labinfo = '\0';		// null-terminate whole thing	

ret = 1 + (t->labinfo - (unsigned char *)t);

t->labinfo = cp;		// 'n' point back to start	

in_fd[test_file].map = t;
in_fd[test_file].curr_mode[0] = t->prog_mode;
in_fd[test_file].curr_mode[1] = t->user_mode;
return ret;
}

static void io_error(mess)
unsigned char *mess;
{
unsigned char filename[MAXFCHARS];
register unsigned char *cp;
register unsigned linecount;

#if	GUI && defined(WINDOWS3)
unsigned char buf[1024];
unsigned char buf2[32];

strcpy(buf, "Stream ");
itoa(test_file,buf2,10);
strcat(buf,buf2);
strcat(buf, ": ");

(*fname)(0, filename, 1);
strcat(buf, filename);
// go to end of this input file 

cp = curr_start_of_line;

for(linecount = 1;;)
	{
	if(*--cp == FORMFEED)break;
	else
		if(*cp == '\n')linecount++;
	}
if(!get_mod_files && mod_fname)
	{
	strcat(buf, " MOD:");
	mod_fname[mod_flen] = 0;
	(*fname)(mod_fname, filename, 1);
	strcat(buf, filename);
	}
strcat(buf, " line ");
itoa(linecount,buf2,10);
strcat(buf,": ");
strcat(buf,buf2);
strcat(buf,"  ");
strcat(buf, mess);
trans_message_box(buf);

#else //GUI && defined(WINDOWS3)

write(2, "Stream ", 7);
eno(test_file);
write(2, ": ", 2);

(*fname)(0, filename, 1);
write(2, filename, strlen(filename));
// go to end of this input file 

cp = curr_start_of_line;

for(linecount = 1;;)
	{
	if(*--cp == FORMFEED)break;
	else
		if(*cp == '\n')linecount++;
	}
if(!get_mod_files && mod_fname)
	{
	write(2, " MOD:",5);
	mod_fname[mod_flen] = 0;
	(*fname)(mod_fname, filename, 1);
	write(2, filename, strlen(filename));
	}
write(2, " line ", 6);
eno(linecount);
write(2, ": ", 2);
write(2, mess, strlen(mess));
write(2, "\n", 1);

#endif//GUI && defined(WINDOWS3)

exit(1);
}

I_DECLARE(i_setnmodes)
{
t->n_modes = setnmodes(cp, ep);
return 0;
}

I_DECLARE(i_lline)
{
unsigned char *wp = cp;

if('+' == *cp)cp = comment(cp, ep);
if(wp  ==  cp)cp = i_label_desc(t, cp, ep);	// old type labels	
if(wp  ==  cp)cp = i_prog_desc(t, cp, ep);
if(wp  ==  cp)cp = i_user_desc(t, cp, ep);
if(wp  ==  cp)cp = modifies_desc(cp, ep);
if(wp  ==  cp)cp = i_statement(t, cp, ep);
return cp;
}

static int i_ascii_char(c)
register SIGNED char	c;
{
	return i_alphabetic(c) || i_digit(c) || i_symbolic(c);
}

static int i_alphabetic(c)
register SIGNED char	c;
{
	return (c >= 'a' && c <= 'z') || (c >= 'A' && c <= 'Z');
}

static int i_digit(c)
register SIGNED char	c;
{
	return (c >= '0' && c <= '9');
}

static int i_symbolic(c)
register SIGNED char	c;
{
	return	   c >= ' '
		&& c <= '~'
		&& !i_alphabetic(c)
		&& !i_digit(c)
		&& c != ':';
}

I_DECLARE(i_statement)
{
unsigned gotcomma = *cp == ',';

cp += gotcomma;
cp = i_header(t, cp, ep);
if(GOT_IT(curr_res))return ep;	// already processed this result 
cp = colon(cp, ep);
cp = i_str_def(t, cp, ep);
cp = white(cp, ep);
cp = comment(cp, ep);
if(!gotcomma)BIT_FLIP(got_it, curr_res - base);
return cp;
}

//***************************************************************************
/*	HEADER PARSING:	LINE CODES.
 *	THIS CODE IS USED BY I_INIT AND QUADSR.
 */

/*	The ordinary line codes recognised in aplkeys files are listed below.
 *
 *	The table MUST be maintained with strings in ascending lexical order,
 *	because lc_str2num uses a binary search on that field.
 *	You MUST NOT rely on the symbolic constants being defined in order -
 *	because they're not.
 *
 *	Codes not listed are those beginning with the following characters:
 *		-	- single-shift mode specification;
 *		F	- Function key specification;
 *		M	- Mode switch specification;
 *		0-9	- quadAV element specification.
 *
 *	Currently no <line code> begins with any of these characters, and they
 *	are handled specially in i_str2num() and i_num2str(). These functions
 *	will need to be fixed if that condition ever changes.
 */

struct s2n_map
	{
	unsigned char	string[2];
	int		code;
	}
	i_line_codes[] =
		{
			{ "BK",	BK },		// BacKward 
			{ "BP", BP },		// toggle BreakPoint 
			{ "BT",	BT },		// Back Tab 
			{ "CP",	CP },		// CoPy 
			{ "CT",	CT },		// CuT 
			{ "D1", D1 },		// Down button 1 
			{ "D2", D2 },		// Down button 2 
			{ "D3", D3 },		// Down button 3 
			{ "D4", D4 },		// Down button 4 
			{ "D5", D5 },		// Down button 5 
			{ "DB",	DB },		// Destructive Backspace 
			{ "DC",	DC },		// Down Character 
			{ "DI",	DI },		// Delete Item 
			{ "DK",	DK },		// Delete Block 
			{ "DL",	DL_ },		// Down Limit 
			{ "DP",	DP },		// Destructive Space 
			{ "DS",	DS },		// Down Screen 
			{ "Dc",	DCS },		// Down line and select 
			{ "Dl",	DLS },		// Down limit and select 
			{ "Ds",	DSS },		// Down page and select 
			{ "ED",	ED },		// EDit 
			{ "EN",	EN },		// End of liNe 
			{ "EP",	EP },		// EscaPe 
			{ "ER",	ER },		// EnteR 
			{ "FD",	FD },		// ForwarD 
			{ "FX",	FX },		// Function fiX 
			{ "HK",	HK },		// Hot Key 
			{ "HO",	HO },		// Home Cursor 
			{ "HT",	HT },		// Horiz Tab - Indent 
			{ "IF",	IF },		// Insert oFf 
			{ "II",	II },		// Insert Item 
			{ "IN",	IN },		// Insert oN 
			{ "JP",	JP },		// JumP 
			{ "LC",	LC },		// Left Character 
			{ "LL",	LL_ },		// Left Limit 
			{ "LN",	LN },		// Line Numbers 
			{ "LS",	LS },		// Left Screen 
			{ "LW",	LW },		// Left word 
			{ "Lc",	LCS },		// Left letter and Select 
			{ "Ll",	LLS },		// Left lne and Select 
			{ "Lw",	LWS },		// Left word and select 
			{ "MC",	MC },		// Mode Change 
			{ "MR",	MR },		// Move / Resize 
			{ "MV",	MV },		// Move Block 
			{ "NB",	NB },		// Non destructive Backspace 
			{ "NS",	NS },		// Non destructive Space 
			{ "NX",	NX },		// NeXt 
			{ "OP",	OP },		// OPen lines 
			{ "PT",	PT },		// PasTe 
			{ "PV",	PV },		// PreVious 
			{ "QT",	QT },		// QuiT 
			{ "RA",	RA },		// Replace All 
			{ "RC",	RC },		// Right Character 
			{ "RD",	RD },		// ReDraw 
			{ "RL",	RL_ },		// Right Limit 
			{ "RP",	RP },		// RePlace 
			{ "RS",	RS },		// Right Screen 
			{ "RT",	RT },		// RepeaT 
			{ "RW",	RW },		// Right word 
			{ "Rc",	RCS },		// Right Letter and select 
			{ "Rl",	RLS },		// Right Line and select 
			{ "Rw",	RWS },		// Right word and select
			{ "SC",	SC },		// SearCh 
#ifdef	INTERRUPTS
			{ "SI",	SI },		// Strong Interrupt 
#endif	// INTERRUPTS 
			{ "ST",	ST },		// Start of line 
			{ "TB",	TB },		// Horizontal Tab 
			{ "TC",	TC },		// TraCe 
			{ "TG",	TG },		// TaG 
			{ "TH",	TH },		// Horiz BackTab - Undent. 
			{ "TL", TGL},		// Toggle Localisation
			{ "U1", U1 },		// Up button 1 
			{ "U2", U2 },		// Up button 2 
			{ "U3", U3 },		// Up button 3 
			{ "U4", U4 },		// Up button 4 
			{ "U5", U5 },		// Up button 5 
			{ "UA",	UA },		// Undo All Changes
			{ "UC",	UC },		// Up Character 
			{ "UL",	UL_ },		// Up Limit 
			{ "US",	US },		// Up Screen 
			{ "Uc",	UCS },		// Up line and select 
			{ "Ul",	ULS },		// Up to top and select 
			{ "Us",	USS },		// Up page and select 
#ifdef	INTERRUPTS
			{ "WI",	WI },		// Weak Interrupt 
#endif	// INTERRUPTS 
			{ "ZM",	ZM }		// ZooM 
		};

#define	NUM_LINE_CODES	(sizeof(i_line_codes) / sizeof(struct s2n_map))

/*	getlinecode
	Does much the same job as i_header: parsing a line code.

	This is done for quadsr in parsing its left argument.
*/

int	getlinecode(cp)
unsigned char	*cp;
{
	unsigned char	*newcp;

	x_error = quadsr_lc_err;	// don't want io_error from quadSR! 

	return lc_str2num(cp, &newcp);
}

/*	getsafelinecode
	Does much the same job as getlinecode parsing a line code.

	This is done for stuff that just needs to know if a code exists for
	the given string
*/

static void	dummy_err(code)
int	code;
{
}

int	getsafelinecode(cp)
unsigned char	*cp;
{
	unsigned char	*newcp;
	void	(*old_x_error)();
	int ret;

	old_x_error = x_error;
	x_error = dummy_err;	// don't want io_error from quadSR! 

	ret = lc_str2num(cp, &newcp);

	x_error = old_x_error;
	return ret;
}


//	see inlab for a clue as to how labels are stored	

I_DECLARE(i_header)
{
	unsigned char	*hp, *wp, *lp;

	hp = i_header_id(t, cp, ep);

	wp = white(hp, ep);

	lp = i_label(t, wp, ep);		// new style labels	

	if(lp != wp)				// a label of sorts	
		{
		unsigned		llen;
		register unsigned char	*sl, *el;

		sl = wp+1;			// first char of label	
		el = lp-1;			// last  char of label	

		while(sl <= el && ' ' == *sl)	// skip leading  spaces	
			++sl;

		while(sl <= el && ' ' == *el)	// skip trailing spaces	
			--el;

		llen = 1 + el - sl;		// trimmed label length	

		if(llen)			// a non-null label	
			{
			unsigned	nlen;

			while(!i_alphabetic(*cp) && !i_digit(*cp))
				++cp;		// skip '-' and ','	     

			nlen = 1 + (hp-1) - cp;	// trimmed name length	     

			if(get_labs)		// installing labels ...     
				{
				register unsigned char	*heap;

				heap = t->labinfo;

				while(nlen--)
					*heap++ = unixtoav(*cp++);

				*heap++ = '\0';

				while(llen--)
					*heap++ = unixtoav(*sl++);

				*heap++ = '\0';

				t->labinfo = heap;
				}
			else			// just counting size ...    
				lab_len += 2 + llen + nlen;
			}
		}

	return lp;
}

I_DECLARE(i_header_id)
{
	unsigned char	*newcp;

	curr_res = lc_str2num(cp, &newcp);	// do || die 

	if(curr_res > 0)	// was a number 
		newcp = i_caps_lock(t, newcp, ep);

	if(curr_res <= M0)	// do tricky things if mode string parsed 
		if(!GOT_IT(curr_res) && curr_mode == (M0 - curr_res))
			t->mode[curr_mode]->istemp = (cp[0] == '-');

	return newcp;
}

I_DECLARE(i_caps_lock)
{
	unsigned char * oldcp = cp;

	cp = white(cp, ep);
	if('-' != *cp++) return oldcp;
	cp = white(cp, ep);
	cp = number(cp, ep);
	if(4 >= lastnumber)(*x_error)(TC_CAPS);
	if(!GOT_IT(curr_res))
		{
		int pair = t->caps_xchg[curr_res];

		if(pair)	// previous pass for another mode 
			{
			if(BIT_READ(t->is_lower, pair))	// or user error 
				(*x_error)(BOTH_LOWER);
			}
		else
			{
			t->caps_xchg[curr_res] = lastnumber;
			t->caps_xchg[lastnumber] = curr_res;
			BIT_FLIP(t->is_lower, curr_res);
			}
		}
	return cp;
}

I_DECLARE(i_label)			// new style labels		
{
	cp = white(cp, ep);

	if(*cp != '=')			// not a label introducer	
		return cp;		// no label			

	while(cp < ep && i_ascii_char(*++cp))
		;

	return cp;
}

I_DECLARE(i_label_desc)			// old style labels		
{
	register unsigned char	*sl, *el, *sn, *en;
	unsigned char *wp = cp;

	if(*wp++ != 'L')
		return cp;		// definitely not a label	

	wp = white(wp, ep);

	if(!i_digit(*wp))
		return cp;		// definitely not a label	

	// definitely a label 

	sn = wp;			// start of F number		

	cp = number(wp, ep);
	curr_res = L0 - lastnumber;

	en = cp;			// beyond end of F number	

	if(GOT_IT(curr_res))
		return ep;		// already seen this definition	

	BIT_FLIP(got_it, curr_res - base);

	cp = colon(cp, ep);		// label follows colon		

	sl = cp;

	while(cp < ep && i_ascii_char(*cp))
		++cp;			// find end of label		
	
	el = cp-1;			// last  char of label	

	while(sl <= el && ' ' == *sl)	// skip leading  spaces	
		++sl;

	while(sl <= el && ' ' == *el)	// skip trailing spaces	
		--el;

	if(get_labs)			// installing labels		
		{
		register unsigned char	*heap;

		heap = t->labinfo;

		*heap++ = unixtoav('F');

		while(sn < en)
			*heap++ = unixtoav(*sn++);

		*heap++ = '\0';		// null-terminate name		

		while(sl <= el)
			*heap++ = unixtoav(*sl++);

		*heap++ = '\0';		// null-terminate label		

		t->labinfo = heap;
		}
	else				// just counting size		
		lab_len += (1 + 1 + el - sl)	// null + inclusive ptrs
			+  (1 + 1 + en - sn);	// null + 'F'		

	cp = white(cp, ep);
	cp = comment(cp, ep);

	return cp;
}

/*	lc_str2num
	Parse a line code. cp points to the first character of the candidate
	line code.

	If cp is a bad line code, an error function is called.

	The numeric code for the string is returned, and the post-line code
	position of cp stored indirect thru the ptr param.
*/

#define	NILt	(struct Imap *)0   // Pass an ignored input translate table 
#define	NILep	(unsigned char *)0 // Pass an ignored end of line pointer   

static int	lc_str2num(cp, cprslt)
register unsigned char	*cp;
unsigned char		**cprslt;
{
	register int		lo;
	register int		hi;
	register int		ix;
	register int		code;
	register unsigned char	*str;
	register struct s2n_map *tabptr;

	switch(*cp)
		{
		case '0': case '1': case '2': case '3': case '4':
		case '5': case '6': case '7': case '8': case '9':
			cp = number(cp, NILep);
			code = lastnumber;

			break;

		case '-':
			cp = white(cp+1, NILep);

			if('M' != *cp) // only mode lines can begin with - 
				(*x_error)(MINUS_NO_M);

			// ... else drop thru to return Mode code ... 

		case 'M':
			if (i_digit(cp[1]))
			{
				cp = number(cp+1, NILep);

				code = M0 - lastnumber;

				break;
			}

		case 'F':
			if (i_digit(cp[1]))
			{
				cp = number(cp+1, NILep);

				code = F0 - lastnumber;

				break;
			}

		default: // Not special? search thru 2-character codes ... 
			 // ... table sorted so binary search is best ...  

			tabptr = i_line_codes;

			lo = 0;
			hi = NUM_LINE_CODES - 1;

			while(lo <= hi)
				{
				register int	rslt;

				ix = (lo + hi) / 2;

				str = tabptr[ix].string;

				if(str[0] != cp[0])
					rslt = (int)str[0] - (int)cp[0];
				else
					rslt = (int)str[1] - (int)cp[1];

				if(rslt < 0)		// too soon in table 
					lo = ix + 1;
				else if(rslt > 0)	// too late in table 
					hi = ix - 1;
				else
					break;
				}
			
			if(hi < lo)
				(*x_error)(UNKNOWN_LC);

			code = tabptr[ix].code;	// found	
			cp += 2;	// skip 2-char line code 

			break;
		}

	*cprslt = cp;
	return code;
}

/*	lc_num2str
	convert a special function code (line code) into a string.

	At the time of writing, no-one but quadSR uses this fn, so I know
	that code DEFINITELY identifies a key, as returned from inkey().

	The pointer is to a bit of static data which is overwritten each call.
*/

unsigned char	*lc_num2str(code)
int	code;
{
	static unsigned char	*fmtnum();
	static unsigned char	cbuf[5]; // room for null-terminated "F255" 
	register unsigned char	*cptr;

	cptr = cbuf;

	if(code <= M0)		// It's a mode setting key		
		{
		*cptr++ = 'M';

		cptr = fmtnum(M0 - code, cptr);
		}
	else if(code <= F0)	// It's a function key			
		{
		*cptr++ = 'F';

		cptr = fmtnum(F0 - code, cptr);
		}
	else if(code < 0)	// It's a plain-jane 2-char line code	
		{
		register struct s2n_map	*tabptr;

		for(tabptr = i_line_codes;
		    tabptr < &i_line_codes[NUM_LINE_CODES];
		    ++tabptr
		   )
			if(code == tabptr->code)
				break;

		if(tabptr < &i_line_codes[NUM_LINE_CODES])
			{
			*cptr++ = unixtoav(tabptr->string[0]);
			*cptr++ = unixtoav(tabptr->string[1]);
			}
		}
	else			// It's a value from quadAV		
		*cptr++ = (unsigned char)code;

	*cptr = (unsigned char)0;	// null-terminate string 
	return cbuf;
}

/*	fmtnum
	Format a small number (0-255) into the char buf cptr, and return ptr
	to next char.
*/

static unsigned char	*fmtnum(num, cptr)
register int		num;
register unsigned char	*cptr;
{
	register int	was;
	register int	div;

	was = num;

	if(was >= 100)
		{
		div = num / 100;
		*cptr++ = '0' + div;
		num -= 100 * div;
		}

	if(was >= 10)
		{
		div = num / 10;
		*cptr++ = '0' + div;
		num -= 10 * div;
		}

	*cptr++ = '0' + num;

	return cptr;
}

/*	END OF HEADER PARSING:	LINE CODES.
 *	THAT CODE IS USED BY I_INIT AND QUADSR.
 */
//***************************************************************************

I_DECLARE(i_str_def)
{
register unsigned i;
register unsigned char *wp = cp;
register unsigned char *last = cp;

for(i = 0; i < t->n_modes; i++)
	{
	if(i == curr_mode)wp = i_strand(t, wp, ep);
	else		// skip strings not for this mode 
		while(*wp==' ' || *wp=='\t' || i_digit(*wp))++wp;
	last = wp > last ? wp : last;
	switch(*wp)
		{
		case ',':
			wp++;			break;
		case '*':
			last += wp == last; wp = cp;	break;
		default:
			return last;
		}
	}
return last;
}

I_DECLARE(i_strand)
{
register unsigned char *wp;
register unsigned len, r;
register unsigned firstnumber;
short *c_or_ip;
register struct Mmap *mp = t->mode[curr_mode];
unsigned dir;
unsigned char string[32];

// get the string into string[] 

wp = string;
for(len = 0;;len++)
	{
	cp = white(cp, ep);
	if(!i_digit(*cp)) break;
	if(len == 30)(*x_error)(STRING2BIG);
	cp = number(cp, ep);
	if(lastnumber > 127)mp->doistrip = 0;
	if(lastnumber == 0)(*x_error)(EMBEDDED_NULL);
	*wp++ = lastnumber;
	}
if(len == 0)
	{
	return cp;	// no string 
	}
*wp = 0;
firstnumber = *string;
#ifdef	INTERRUPTS
if(curr_res == WI)
	{
	if(len != 1)(*x_error)(WEAK2BIG);
	if(curr_mode == 0)t->weak_int = firstnumber;
	else if(firstnumber != t->weak_int)
		(*x_error)(WEAK_MODES);
	}
if(curr_res == SI)
	{
	if(len != 1)(*x_error)(STRONG2BIG);
	if(curr_mode == 0)t->strong_int = firstnumber;
	else if(firstnumber != t->strong_int)
		(*x_error)(STRONG_MODES);
	}
#endif	// INTERRUPTS 

dir = ISDIRECT(mp, firstnumber);
c_or_ip = &t->mode[curr_mode]->char_or_index[firstnumber];
if(len == 1 && curr_res >= 0 /* && curr_res < RHOQUADAV */ && dir)
	{
	if(!*c_or_ip)
		{
		// simple case - maps directly 
		// new entry - no problem 
		
		*c_or_ip = curr_res;
		return cp;
		}
	else
		{
		/*
		 * complex case - either
		 * 	already indirect or
		 *	currently direct and needs to be indirect
		 *
		 * in each of the above it is like a multi byte string
		 * so fall through
		 */
		}
	}
// need to change strs matrix 
if(mp->cols <= len)up_cols(t, mp, 1 + len - mp->cols);
if(dir)
	{
	/*
	 * Find the entry which starts with a number bigger than 
	 * firstnumber or the entry that starts with 0
	 */

	for(r=0,wp=mp->strs; *wp && *wp <= firstnumber; r++, wp += mp->cols);
	if(*c_or_ip)
		{
		/*
		 * we need to take the current direct entry and insert it into
		 * the matrix. The matrix will already be wide enough and the
		 * entry will be the only one starting with firstnumber.
		 */

		if(len == 1) (*x_error)(DUP_STRING);	// bug 701 
		up_rows(t, mp, r);
		
		wp = mp->strs + r*mp->cols;
		*wp++ = firstnumber; *wp = 0;
		mp->result[r] = *c_or_ip;
		*c_or_ip = 0;
		}
	BIT_FLIP(mp->direct, firstnumber);
	}
else
	{
	for(r = 0;;r++)
		{
		unsigned sl;
		unsigned char *tp;

		/*
		 * matrix is kept sorted by string within string length within
		 * first character
		 */

		wp = mp->strs + r*mp->cols;
		if(!*wp)break;
		if(firstnumber < *wp)break;
		if(firstnumber > *wp)continue;
		sl = strlen(wp);
		if(sl < len)break;
		if(sl > len)continue;
		// sl == len 
		if(0 == strcmp(wp, string))(*x_error)(DUP_STRING);
		// cant rely on sign of strcmp - we are using unsigned chars 
		for(tp = string; *wp == *tp; wp++, tp++);
		if(*wp > *tp) break;
		}
	}
// r now points to the row we wish to insert in front of 
up_rows(t, mp, r);
strcpy(mp->strs + r*mp->cols, string);
mp->result[r] = curr_res;
return cp;
}

I_DECLARE(i_index)
{
register unsigned i,j,r,c;
register unsigned char *wp;
short *c_or_ip;
struct Mmap *mp;

mp = t->mode[curr_mode];
r = mp->rows;
c = mp->cols;
wp = mp->strs + r*c;
c_or_ip = mp->char_or_index;

for(i=r; wp -= c, i--;)
	{
	c_or_ip[*wp] = i;
	for(j = 0; j<c ; j++)if(!wp[j])break;
	for(;j<c; j++)wp[j] = 0;
	}
return cp;
}

static unsigned char	*i_pu_desc(n_modes, cp, ep, modep, pustr, puval, puerr)
unsigned char	n_modes;
register unsigned char	*cp, *ep;
unsigned char	*modep;			// &t->prog_mode or &t->user_mode 
unsigned char  *pustr;			// "PROG" or "USER"		
int		puval;			//  PROG  or  USER		
int		puerr;			// PROG_MODE or USER_MODE	
{
if(0 != memcmp(cp, pustr, 4)) return cp;
if(GOT_IT(puval))return ep;
cp = colon(cp + 4, ep);
cp = number(cp, ep);
*modep = lastnumber;
if(lastnumber >= n_modes)(*x_error)(puerr);
cp = white(cp, ep);
cp = comment(cp, ep);
BIT_FLIP(got_it, puval - base);
return cp;
}

I_DECLARE(i_prog_desc)
{
return i_pu_desc(t->n_modes, cp, ep, &t->prog_mode, "PROG", PROG, PROG_MODE);
}

I_DECLARE(i_user_desc)
{
return i_pu_desc(t->n_modes, cp, ep, &t->user_mode, "USER", USER, USER_MODE);
}

	/*
	 *	OUTPUT MAP INTERPRETER
	 */


/*
 B.N.F.
	<line>		::=<white><lline><newline>
	<lline>		::=<statement>|<nmodes desc>|<modifies desc>|<comment>
	<comment>	::=<null>|+<anything>

	<statement>	::=<header><colon><str def><white><comment>|
			   <n_header><colon><strand>
	<white>		::=<null>|<white delim>|<white>
	<white delim>	::=<space>|<tab>|<cr>
	<header>	::=M<white><number>|<number>|CC
	<n_header>	::=INIT|
			   RESET|
			   V<white><number>|
			   C<white><number>|
			   B<white><number>
	<str def>	::=<strands>|<strands>*
	<strands>	::=<strand>|<strand><white>,<strands>
	<strand>	::=<white>|
			   <white><number>|
			   <white><number><white delim><white><strand>
	<number>	::=0|1|...|255
	<colon>		::=<white><colon><white>

	<modifies desc>	::=MOD<colon><filename><white><comment>
	<filename>	::=<fullpathname>|<apltrans relative pathname>

	not expanded
		<fullpathname>
		<apltrans relative pathname>
		<null>
		<anything>
		<space>
		<tab>
		<cr>	N.B. not newline
 */

#define DECLARE(name)	static unsigned char *name(t, cp, ep)	\
			register struct Translate *t;		\
			register unsigned char *cp, *ep;

unsigned char
	*lline(), *statement(), *header(),
	*n_header(), *str_def(), *strand();

#define NMODED	512		// allows for 256 modes + CC + lots of spare 
static unsigned currline;	// current line number in translate output 
static int currcode;		// current code of non-moded string 

DECLARE(o_setnmodes)
{
t->nmodes = setnmodes(cp, ep);
t->nmodes += 0 == t->nmodes;
return 0;
}

DECLARE(lline)
{
unsigned char *wp = cp;

if('+' == *cp)cp = comment(cp, ep);
if(wp  ==  cp)cp = modifies_desc(cp, ep);
if(wp  ==  cp)cp = statement(t, cp, ep);
return cp;
}

DECLARE(statement)
{
register unsigned char *wp = cp;

wp = header(t, wp, ep);
if(wp != cp)		// moded statement 
	{
	if(GOT_IT(currline)) return ep;
	BIT_FLIP(got_it, currline - base);
	wp = colon(wp, ep);
	wp = str_def(t, wp, ep);
	wp = white(wp, ep);
	wp = comment(wp, ep);
	return wp;
	}
wp = n_header(t, wp, ep);
if(wp != cp)		// non_moded statement 
	{
	unsigned char *start = currstr;

	if(GOT_IT(currcode)) return ep;
	BIT_FLIP(got_it, currcode - base);
	t->special--;	// allocate space strand() tests for overflow 
	t->nsas++;
	wp = colon(wp, ep);
	wp = strand(t, wp, ep);
	t->special->code = currcode;
	t->special->offset = start - t->strstart;
	t->special->len = currstr - start;
	wp = comment(wp, ep);
	return wp;
	}
wp = comment(wp, ep);	// will force error if neither case 
return wp;
}

DECLARE(header)
{
switch(*cp)
	{
	case 'M':
		cp++; cp = white(cp, ep); cp = number(cp, ep);
		currline = MODE0 + lastnumber;
		break;
	case 'C':
		if('C' == cp[1])
			{
			currline = CC;
			cp += 2;
			}
		break;
	case '0': case '1': case '2': case '3': case '4':
	case '5': case '6': case '7': case '8': case '9':
		cp = number(cp, ep);
		currline = lastnumber;
		break;
	}
return cp;
}

DECLARE(n_header)
{
switch(*cp)
	{
	case 'I':
		if(0 == memcmp(cp, "INIT", 4))
			{
			cp += 4;
			currcode = INIT;
			}
		break;
	case 'R':
		if(0 == memcmp(cp, "RESET", 5))
			{
			cp += 5;
			currcode = RESET;
			}
		break;
	case 'V':
		cp++;
		cp = white(cp, ep);
		cp = number(cp, ep);
		currcode = V0 - lastnumber;
		break;
	case 'C':
		cp++;
		cp = white(cp, ep);
		cp = number(cp, ep);
		currcode = C0 - lastnumber;
		break;
	case 'B':
		cp++;
		cp = white(cp, ep);
		cp = number(cp, ep);
		currcode = B0 - lastnumber;
		break;
	}
return cp;
}

static testbuf(t, addr)	// test for overrun of allocated buffer 
struct Translate *t;
unsigned char *addr;
{
if(addr >= (unsigned char *)t->special) t_abort();
}

DECLARE(str_def)
{
register unsigned char *wp = cp;
register unsigned char *start;
register unsigned char *lp;
register unsigned i = t->nmodes;
register unsigned char *last = cp;

lp = t->lengths + i*currline;
testbuf(t, (unsigned char *)(t->offset + currline));
t->offset[currline] = currstr -  t->strstart;
while(i--)
	{
	start = currstr;
	wp = strand(t, wp, ep);
	testbuf(t, (unsigned char *)lp);
	*lp++ = currstr - start;	// store the length 
	last = wp > last ? wp : last;
	switch(*wp)
		{
		case ',':
			wp++;			break;
		case '*':
			last += wp == last;	wp = cp;	break;
		default:
			return last;
		}
	}
return last;
}

DECLARE(strand)
{
for(;;)
	{
	cp = white(cp, ep);
	if(!i_digit(*cp))return cp;
	cp = number(cp, ep);
	testbuf(t, (unsigned char *)currstr);
	*currstr++ = lastnumber;	// store it in strings 
	}
}

static unsigned o_any_get(struct Translate *t)
{
unsigned char *cp;
unsigned char *ep = &workbuf[sizeof(workbuf)];
unsigned char l_got_it[(RHOQUADAV + NMODED - COMMAND_BASE)/8];

got_it = l_got_it;
cp = fillmod(workbuf, ep);
o_setnmodes(t, cp, ep);

t->offset = (unsigned short *)t->dynamic;
t->lengths = t->dynamic + (MODE0 + t->nmodes)*sizeof(unsigned short);
currstr = t->strstart = t->lengths + (MODE0+t->nmodes)*t->nmodes;
t->special = (struct Sas *)currbuflim;

initbytes(l_got_it, sizeof(l_got_it), 0);
cp = line(t, cp, ep, lline);
o_out[test_file]->t_out = t;

// move the special strings down in memory
if(1 & (unsigned)currstr) ++currstr;	// get to an even boundary
memmove(currstr, t->special, t->nsas * sizeof(struct Sas));
t->special = (void *)currstr;

// find the INIT string (if any) and put it first 
	{
	register unsigned i = t->nsas;

	while(i--)if(t->special[i].code == INIT)
		{
		struct Sas temp;

		temp = *t->special;
		*t->special = t->special[i];
		t->special[i] = temp;
		}
	}
return (unsigned char *)&t->special[t->nsas] - (unsigned char *)t;
}




	/*
	 *	DATE MAP INTERPRETER
	 */


/*
 B.N.F.
	<line>		::=<white><lline><newline>
	<lline>		::=<statement>|<comment>
	<comment>	::=<null>|+<anything>
	<statement>	::=<date_defn><white><comment>

	<date_defn>	::=<dm_header><colon><dm_desc>|
			   <fmt_header><fmt_label><colon><fmt_desc>

	<dm_header>	::= D<white>|
			    M<white>
	<dm_desc>	::=<dm_name>|
			   <dm_name><white space><dm_desc>
	<dm_name>	::=<alphabetic>|<alphabetic><alphabetic><alphabetics>

	<fmt_header>	::=F<white><number>
	<fmt_label>	::=<null>|=<ascii string>
	<fmt_desc>	::=<ascii char>|<ascii char><ascii char><ascii string>

	<ascii string>	::=<null>|<ascii char><ascii string>
	<ascii char>	::=<alphabetic>|<symbolic>|<digit>|<space>
	<colon>		::=<white>:<white>
	<alphabetics>	::=<null>|<alphabetic><alphabetics>
	<number>	::=0|1|...|255
	<white>		::=<null>|<white delim><white>
	<white space>	::=<white delim>|<white delim><white space>
	<white delim>	::=<space>|<tab>

	not expanded
		<null>
		<space>
		<tab>
		<digit>
		<alphabetic>	N.B. a-z A-Z
		<symbolic>	N.B. -=`[];'\,./!@#$%^&*()_+~{}"|<>? and space
			i.e. 7-bit ASCII printable less alphanumerics & ':'
 */

/*
	struct Datemap	used to store the local information of day names,
			month names, and formats requested in quadSM.
	int datemaperr	used to indicate whether a valid date map has been
			read for quadSM, and indicates which error if an
			error occured.
*/

static struct Datemap	*datemap;
int			datemaperr;
static jmp_buf		datebuf;
static unsigned		lastdayno;
static unsigned		lastmonthno;

#define D_DECLARE(name)	static unsigned char *name(t, cp, ep)	\
			register struct Datemap *t;		\
			register unsigned char *cp, *ep;

#define BAD_DATE_ACCESS	70
#define BAD_DATE_SYNTAX	71
#define ESC_CHAR	0x5c

unsigned char	*d_lline(),
		*d_statement(),
		*d_dm_header(),
		*d_dm_desc(),
		*d_dm_name(),
		*d_fmt_header(),
		*d_fmt_label(),
		*d_fmt_desc();

void		d_error();

D_DECLARE(d_lline)
{
unsigned char *wp = cp;

if('+' == *cp)cp = comment(cp, ep);
if(wp  ==  cp)cp = d_statement(t, cp, ep);
return cp;
}

D_DECLARE(d_statement)
{
register unsigned char *wp = cp;

wp = d_dm_header(t, wp, ep);
if(wp != cp)
	{
	wp = colon(wp, ep);
	wp = d_dm_desc(t, wp, ep);
	wp = white(wp, ep);
	wp = comment(wp, ep);
	return wp;
	}
wp = d_fmt_header(t, wp, ep);
if(wp != cp)
	{
	if(GOT_IT(currcode)) return ep;
	wp = d_fmt_label(t, wp, ep);
	wp = colon(wp, ep);
	wp = d_fmt_desc(t, wp, ep);
	wp = white(wp, ep);
	wp = comment(wp, ep);
	return wp;
	}
wp = comment(wp, ep);	// will force error if none of these cases 
return wp;
}

D_DECLARE(d_fmt_header)
{
if (*cp == 'F')
	{
	cp++;
	cp = white(cp, ep);
	cp = number(cp, ep);
	t->n_formats++;
	currcode = DF0 - lastnumber;
	}
return cp;
}

D_DECLARE(d_fmt_label)
{
unsigned char *wp;
unsigned len = 0;
unsigned char *start = currstr;
int formatcode = currcode;

	if (*cp == ':')
		return cp;
	if(*cp != '=') (*x_error)(BAD_DATE_SYNTAX);

	wp = ++cp;
	for(;wp<ep && *wp != ':';)
	    {
	    unsigned class = 0;

	    if(*wp == ESC_CHAR) class = 1;
	    else if(*wp >= ' ' && *wp <= '~') class = 2;
	    switch(class)
		{
		case 0: wp++;
			break;
		case 1: len++;
			wp+=4;
			continue;
		case 2: len++;
			wp++;
			continue;
		}
	    }
	
	t->n_labels++;
	currcode = DL0 - lastnumber;
	BIT_FLIP(got_it, currcode - base);
	t->strings--;
	while (len--)
	    {
	    d_testbuf(t, (unsigned char *)currstr);
	    if (*cp != ESC_CHAR)
		*currstr++ = unixtoav(*cp++);
	    else
		{
		cp = number(cp+1, ep);
		*currstr++ = lastnumber;
		}
	    }
	*currstr++ = 0;
	t->strings->code = currcode;
	t->strings->offset = start - t->strstart;
	t->strings->len = currstr - 1 - start;
	currcode = formatcode;
	return cp;
}

D_DECLARE(d_fmt_desc)
{
unsigned char *wp = cp;
unsigned spaces = 0;
unsigned len = 0;
unsigned char *start = currstr;

	for(;wp<ep && *wp != '+';)
	    {
	    unsigned class = 0;

	    if(*wp == ' ') class = 1;
	    else if(*wp == ESC_CHAR) class = 2;
	    else if(*wp > ' ' && *wp <= '~') class = 3;
	    switch(class)
		{
		case 0: wp++;
			break;
		case 1: spaces++;
			wp++;
			continue;
		case 2: len += spaces;
			spaces = 0;
			len++;
			wp+=4;
			continue;
		case 3: len += spaces;
			spaces = 0;
			len++;
			wp++;
			continue;
		}
	    }
	
	if(!len) (*x_error)(BAD_DATE_SYNTAX);
	BIT_FLIP(got_it, currcode - base);
	t->strings--;
	while (len--)
	    {
	    d_testbuf(t, (unsigned char *)currstr);
	    if (*cp != ESC_CHAR)
		*currstr++ = unixtoav(*cp++);
	    else
		{
		cp = number(cp+1, ep);
		*currstr++ = lastnumber;
		}
	    }
	*currstr++ = 0;
	t->strings->code = currcode;
	t->strings->offset = start - t->strstart;
	t->strings->len = currstr - 1 - start;
	return cp;
}

static d_testbuf(t, addr)	// test for overrun of allocated buffer 
struct Datemap *t;
unsigned char *addr;
{
if(addr >= (unsigned char *)t->strings) (*x_error)(BAD_DATE_ACCESS);
}

D_DECLARE(d_dm_header)
{
switch(*cp)
	{
	case 'D' :
		cp++;
		cp = white(cp, ep);
		currcode = D0 - lastdayno;
		break;
	case 'M' :
		cp++;
		cp = white(cp, ep);
		currcode = MN0 - lastmonthno;
		break;

	}
return cp;
}

D_DECLARE(d_dm_desc)
{
register struct Sas	*s = t->strings;
int		currnum;
register int	nread, num;

	currnum = currcode;

	for(;cp<ep && *cp != '+';)
		{
		cp = d_dm_name(t, cp, ep);
		cp = white(cp, ep);
		}
	nread = currnum - currcode;

	for (num = 0; num < nread; num++)
		{
		s--;
		if (currcode <= MN0)
			s->code = MN0 - (12 - lastmonthno) - num;
		else
			s->code = D0 - (7 - lastdayno) - num;
		}
return cp;
}

D_DECLARE(d_dm_name)
{
unsigned char *wp = cp;
unsigned char *start = currstr;

unsigned len = 0;

	while( ( i_alphabetic(*wp)	||
		 (*wp == ESC_CHAR)
	       )
		&& wp < ep)
		{
		if (*wp != ESC_CHAR)
			wp++;
		else
			wp+=4;
		len++;
		}

	if(!len) (*x_error)(BAD_DATE_SYNTAX);
	BIT_FLIP(got_it, currcode - base);
	t->strings--;
	while (len--)
	    {
	    d_testbuf(t, (unsigned char *)currstr);
	    if (*cp != ESC_CHAR)
		*currstr++ = unixtoav(*cp++);
	    else
		{
		cp = number(cp+1, ep);
		*currstr++ = lastnumber;
		}
	    }
	*currstr++ = 0;
	t->strings->code = currcode;
	t->strings->offset = start - t->strstart;
	t->strings->len = currstr - 1 - start;
	if(currcode <= MN0)
		{
		t->n_months++;
		lastmonthno++;
		}
	else
		{
		t->n_days++;
		lastdayno++;
		}
	currcode--;
	return cp;
}

static ino_t date_inode;
static dev_t date_device;

static void d_fname	// develop a date file name 
	(
	unsigned char *tp		// null or target file name 
,	unsigned char *buf		// where to put the file name 
,	unsigned errflag		// an error condition ? 
	)
{
	static unsigned char envdir[] = "APLFMT";
	static unsigned char dirname[] = "aplfmt";
	static unsigned char envname[] = "APLF  ";
	static unsigned char ext[] = ".DFT";
	unsigned char tbuf[127];
	unsigned char *ep, *dp;
	static unsigned skip;

if(!buf)
	{
	// initialise static data 
	skip = 0;
	date_device = 0;	// set last device read to impossible 
	date_inode = 0;		// values 
	return;
	}
if(!tp)
	{
	ep = envname + 4;
	if(test_file>9)*ep++ = '0' + test_file/10;
	*ep++ = '0' + test_file%10;
	*ep=0;

	ep = (void *)getenv(envname);
	if(0 == ep)
		{
		*(envname+4) = 0;	// "APLF" 
		ep = (void *)getenv(envname);
		if(0 == ep) ep = (unsigned char *)"default";
		}
	tp = ep;
	}
strcpy(tbuf, tp);
tp = tbuf;
strcat(tbuf, fextend(tbuf, ext));
if(strcspn(tp, PUNCTUATION) == strlen(tp))	// relative pathname ? 
	{
	switch(0 != (dp = (void *)getenv(envdir)))
	    {
	    default:
		{
		struct stat sbuf;
		unsigned count;

		sbuf.st_dev = 0; // in case we dont succesfully stat 
		sbuf.st_ino = 0; // a file 
		buf[0] = 0;	 // in case APLFMT exists but is 0
		for(count = 0 ;;skip += count++ == skip, dp += *dp != 0)
		    {
		    unsigned char *bp = dp;
		    unsigned n;

		    dp += strcspn(dp, pathdelim);
		    if(bp == dp)break;
		    if(count == skip)
			{
			strncpy(buf, bp, n = dp - bp);
			buf[n] = 0;
			strcat(buf, dirdelim);
			strcat(buf,tp);
			if
			    (
/* got a file */		-1 != stat(buf, &sbuf) &&
/* is a plain file */		S_IFREG == (S_IFREG & sbuf.st_mode) &&
/* is an error */		errflag
			    )break;
			}
		    }
		dev_inode(&sbuf, &date_device, &date_inode);
		}
		break;
	    case 0:		// build the default 
		dp = (void *)getenv("DYALOG");
		if(0 == dp)
#if	defined(DOS)
			dp = (unsigned char *)"c:\\dyalog";
#elif defined(MAINWIN)
			dp = (unsigned char *)"/usr/mdyalog";
#elif defined(WINDOWS3)
			dp = (unsigned char *)"c:\\wdyalog";
#else	
			dp = (unsigned char *)"/usr/dyalog";
#endif	
		strcpy(buf, dp);
		strcat(buf, dirdelim);
		strcat(buf, dirname);
		strcat(buf, dirdelim);
		strcat(buf,tp);
		break;
		}
	    }
    else strcpy(buf, tp);
}

static unsigned d_any_get(struct Datemap *t);

static void d_filbuf(void)
{
unsigned char *buf = malloc(MAX_BUF);
register struct Datemap *t = (struct Datemap *)buf;
register struct Datemap *new;

if(0 == buf) (*x_error)(MALLOC_FAIL);
currbuflim = buf + MAX_BUF;
initbytes(buf, MAX_BUF, 0);
t->inode = date_inode;
t->device = date_device;
currstr = t->strstart = t->dynamic;
t->strings = (struct Sas *)currbuflim;
datemap = t;
new = realloc(t, d_any_get(t));
assert(new == t);		// make sure it didn't move when shrunk
}

static void d_finish(void)
	{
	if(datemap) free(datemap);
	}

void d_init()
{
void
	d_filbuf(),
	i_init();

struct stat statbuf;
unsigned char  envbuf[MAXFCHARS];

if(!x_error) x_error = d_error;
datemaperr = 0;			// no errors to start with		
d_fname(0, 0, 0);		// init statics for top level request	
d_fname(0, envbuf, 0);		// put file name to read in envbuf	

if (
	(-1 == (trans_file = open(envbuf, O_RDONLY | O_BINARY))) ||// cant open 
	(-1 == fstat(trans_file, &statbuf))	// no file 
	) 
		datemaperr = BAD_DATE_ACCESS;
else
	{
	trans_size  = statbuf.st_size;
	dev_inode(&statbuf, &trans_dev, &trans_inode);

#if defined(DOSWIN)
	binary_file(trans_file);
#endif
	if(setjmp(datebuf))
		{
		datemaperr = BAD_DATE_SYNTAX;
		}
	else
		{
		d_filbuf();

		if
			(
			datemap->n_days    !=  7
		||	datemap->n_months  != 12
		||	datemap->n_formats >  10
			)
			datemaperr = BAD_DATE_SYNTAX;
		}
	}
atexit(d_finish);
i_init();	// get the keyboard tables 
}



static unsigned d_any_get(struct Datemap *t)
{
unsigned char *cp;
unsigned char *ep = &workbuf[sizeof(workbuf)];
unsigned char l_got_it[(RHOQUADAV + NMODED - COMMAND_BASE)/8];
unsigned extra;

got_it = l_got_it;
cp = fillmod(workbuf, ep);
initbytes(l_got_it, sizeof(l_got_it), 0);
lastdayno = lastmonthno = 0;
cp = line(t, cp, ep, d_lline);
currstr = w_align(currstr, t);
extra = currbuflim - (unsigned char *)t->strings;
memmove(currstr, t->strings, extra);
t->strings = (void *)currstr;
currstr += extra; 
return currstr - (unsigned char *)t;
}


static struct Sas *get_date_s(short code)
	{
	struct Sas *s = datemap->strings;
	unsigned n = datemap->n_days
	+	datemap->n_months
	+	datemap->n_formats
	+	datemap->n_labels
	;

	for(++n, --s; --n && code != (++s)->code;);
	return n ? s : 0;
	}

unsigned char	*get_date_string(short code)
	{
	struct Sas *s = get_date_s(code);

	return s ? datemap->strstart + s->offset : 0;
	}

short unsigned get_date_length(short code)
	{
	struct Sas *s = get_date_s(code);

	return s ? s->len : 0;
	}

void d_error(int err_no)
{
	datemaperr = (err_no == BAD_DATE_ACCESS)
			? BAD_DATE_ACCESS
			: BAD_DATE_SYNTAX;

	longjmp(datebuf, 1);
}


#undef getenv

char *getenv(const char *);

void *get_ours(const void *envname)
{

typedef struct
	{
	void * name;
	void * value;
	} ENV_DEF;
ENV_DEF our_defaults[] =
#if	defined(DOS)
	{
		{ "DYALOG",	"C:\\DYALOG" },
		{ "TERM",	"DOS" },
		{ "MAPCHARS",	"db0deba7eec00be0" },
		{ "MAXWS",	"4096" },
		{ "WSPATH",	".;C:\\DYALOG\\WS;C:\\DYALOG\\XFLIB" },
		{ "APLNID",	"0" },
		{ "APLCOMI",	"4080" },
		{ "APLCOMO",	"16" },
		{ "APLBLINK",	"OFF" },
		{ 0,		0 }
	};
#elif	GUI && defined(MAINWIN)
	{
		{ "APLFSCB_HOST","aplfscb"	},
		{ "APLK",	"apl_us" 	},
		{ "APLNID",	"0" 		},
		{ "DYALOG",	"/usr/mdyalog"	},
		{ "LOG_FILE",	"/dev/null" 	},
		{ "LOG_SIZE",	"80" 		},
		{ "MAPCHARS",	"db0deba7eec00be0" },
		{ "MAXWS",	"4096" 		},
		{ "SESSION_FILE", "default.dse" },
		{ "TERM",	"win" 		},
		{ "TMP",	"" 		},
		{ "WSPATH",	".:/usr/mdyalog/ws:/usr/mdyalog/xflib"},
		{ 0,		0 		}
	};
#elif	GUI && defined(WINDOWS3)
	{
		{ "APLNID",	"0" },
		{ "LOG_FILE",	"nul" },
		{ "LOG_SIZE",	"80" },
		{ "MAPCHARS",	"db0deba7eec00be0" },
		{ "MAXWS",	"4096" },
		{ "TERM",	"WIN" },
		{ "TMP",	"" },
		{ "WSPATH",	"."},
		{ 0,		0 }
	};
#else	
	{
		{ "APLFSCB_HOST",	"aplfscb"},
		{ "APLK",	"apl_us" 	},
		{ "DYALOG",	"/usr/dyalog" },
		{ "LOG_FILE",	"/dev/null" 	},
		{ "LOG_SIZE",	"80" 		},
		{ "MAPCHARS",	"db0deba7eec00be0" },
		{ "MAXWS",	"4096" },
		{ "TMP",	"" 		},
		{ "WSPATH",	".:/usr/mdyalog/ws:/usr/mdyalog/xflib" },
		{ 0,		0 }
	};
#endif	

ENV_DEF *ours;

for(ours = our_defaults; ours->name ; ours++)
	{
	if(0 == strcmp(ours->name, envname))return ours->value;
	}
return 0;

}

void * (*special_getenv)(const void *);	// hook for special cases 

char * shad_getenv(const char *envname)
{
char * res;
#if	defined(WINDOWS3)
extern void *W3getenv(const void *);
#endif//defined(WINDOWS3)


if(special_getenv && (res = (*special_getenv)(envname))) return res;

#if	defined(WINDOWS3)
if(res = W3getenv(envname))return res;
#else //defined(WINDOWS3)
if(res = (void *)getenv(envname))return res;
#endif//defined(WINDOWS3)

return get_ours(envname);

}

// National language friendly 1-1 AV to ANSI mapping	

unsigned char av_ansi_dflt[] =
{
//	   AV APL-char		     NB	     ->	ANSI	   ANSI-char	     

	/* 00 Null			*/	0x00,	/* ctrl: NUL	     */
	/* 01 Backspace			*/	0x08,	/* ctrl: BS	     */
	/* 02 Line feed			*/	0x0a,	/* ctrl: LF	     */
	/* 03 Carriage return		*/	0x0d,	/* ctrl: CR	     */
	/* 04 Space			*/	0x20,	/* <space>	     */
	/* 05 Form feed			*/	0x0c,	/* ctrl: FF	     */
	/* 06			(spare)	*/	0x06,	/* ctrl: ACK	     */
	/* 07 Bell			*/	0x07,	/* ctrl: BEL	     */
	/* 08 Escape			*/	0x1b,	/* ctrl: ESC	     */
	/* 09 Tab			*/	0x09,	/* ctrl: HT	     */
	/* 0a I-Beam			*/	0x0b,	/* ctrl: VT	     */
	/* 0b Stile bar			*/	0x0e,	/* ctrl: SO	     */
	/* 0c Percent			*/	0x25,	/* % percent sign    */
	/* 0d APL-Quote			*/	0x27,	/* ' apostrophe	     */
	/* 0e Alpha			*/	0xb8,	/* , spacing cedilla */
	/* 0f Omega			*/	0xbe,	/*   three quarters  */

	/* 10 Underscore		*/	0x5f,	/* _ underscore	     */
	/* 11 Lower a			*/	0x61,	/* a small letter    */
	/* 12 Lower b			*/	0x62,	/* b small letter    */
	/* 13 Lower c			*/	0x63,	/* c small letter    */
	/* 14 Lower d			*/	0x64,	/* d small letter    */
	/* 15 Lower e			*/	0x65,	/* e small letter    */
	/* 16 Lower f			*/	0x66,	/* f small letter    */
	/* 17 Lower g			*/	0x67,	/* g small letter    */
	/* 18 Lower h			*/	0x68,	/* h small letter    */
	/* 19 Lower i			*/	0x69,	/* i small letter    */
	/* 1a Lower j			*/	0x6a,	/* j small letter    */
	/* 1b Lower k			*/	0x6b,	/* k small letter    */
	/* 1c Lower l			*/	0x6c,	/* l small letter    */
	/* 1d Lower m			*/	0x6d,	/* m small letter    */
	/* 1e Lower n			*/	0x6e,	/* n small letter    */
	/* 1f Lower o			*/	0x6f,	/* o small letter    */

	/* 20 Lower p			*/	0x70,	/* p small letter    */
	/* 21 Lower q			*/	0x71,	/* q small letter    */
	/* 22 Lower r			*/	0x72,	/* r small letter    */
	/* 23 Lower s			*/	0x73,	/* s small letter    */
	/* 24 Lower t			*/	0x74,	/* t small letter    */
	/* 25 Lower u			*/	0x75,	/* u small letter    */
	/* 26 Lower v			*/	0x76,	/* v small letter    */
	/* 27 Lower w			*/	0x77,	/* w small letter    */
	/* 28 Lower x			*/	0x78,	/* x small letter    */
	/* 29 Lower y			*/	0x79,	/* y small letter    */
	/* 2a Lower z			*/	0x7a,	/* z small letter    */
	/* 2b			(spare)	*/	0x01,	/* ctrl: SOH	     */
	/* 2c			(spare)	*/	0x02,	/* ctrl: STX	     */
	/* 2d High Minus		*/	0xaf,	/*   spacing macron  */
	/* 2e Period			*/	0x2e,	/* . period	     */
	/* 2f Zilde			*/	0xab,	/*   left guillemet  */

	/* 30 Zero			*/	0x30,	/* 0 digit zero	     */
	/* 31 One			*/	0x31,	/* 1 digit one	     */
	/* 32 Two			*/	0x32,	/* 2 digit two	     */
	/* 33 Three			*/	0x33,	/* 3 digit three     */
	/* 34 Four			*/	0x34,	/* 4 digit four	     */
	/* 35 Five			*/	0x35,	/* 5 digit five	     */
	/* 36 Six			*/	0x36,	/* 6 digit six	     */
	/* 37 Seven			*/	0x37,	/* 7 digit seven     */
	/* 38 Eight			*/	0x38,	/* 8 digit eight     */
	/* 39 Nine			*/	0x39,	/* 9 digit nine	     */
	/* 3a			(spare)	*/	0x03,	/* ctrl: ETX	     */
	/* 3b Int'l currency sumbol	*/	0xa4,	/*   currency sign   */
	/* 3c Japanese Yen		*/	0xa5,	/*   yen sign	     */
	/* 3d Dollar			*/	0x24,	/* $ dollar sign     */
	/* 3e Pound Sterling		*/	0xa3,	/*   pound sign	     */
	/* 3f Cent			*/	0xa2,	/*   cent sign	     */

	/* 40 Delta			*/	0x91,	/* ctrl: reserved    */
	/* 41 Upper A			*/	0x41,	/* A capital letter  */
	/* 42 Upper B			*/	0x42,	/* B capital letter  */
	/* 43 Upper C			*/	0x43,	/* C capital letter  */
	/* 44 Upper D			*/	0x44,	/* D capital letter  */
	/* 45 Upper E			*/	0x45,	/* E capital letter  */
	/* 46 Upper F			*/	0x46,	/* F capital letter  */
	/* 47 Upper G			*/	0x47,	/* G capital letter  */
	/* 48 Upper H			*/	0x48,	/* H capital letter  */
	/* 49 Upper I			*/	0x49,	/* I capital letter  */
	/* 4a Upper J			*/	0x4a,	/* J capital letter  */
	/* 4b Upper K			*/	0x4b,	/* K capital letter  */
	/* 4c Upper L			*/	0x4c,	/* L capital letter  */
	/* 4d Upper M			*/	0x4d,	/* M capital letter  */
	/* 4e Upper N			*/	0x4e,	/* N capital letter  */
	/* 4f Upper O			*/	0x4f,	/* O capital letter  */

	/* 50 Upper P			*/	0x50,	/* P capital letter  */
	/* 51 Upper Q			*/	0x51,	/* Q capital letter  */
	/* 52 Upper R			*/	0x52,	/* R capital letter  */
	/* 53 Upper S			*/	0x53,	/* S capital letter  */
	/* 54 Upper T			*/	0x54,	/* T capital letter  */
	/* 55 Upper U			*/	0x55,	/* U capital letter  */
	/* 56 Upper V			*/	0x56,	/* V capital letter  */
	/* 57 Upper W			*/	0x57,	/* W capital letter  */
	/* 58 Upper X			*/	0x58,	/* X capital letter  */
	/* 59 Upper Y			*/	0x59,	/* Y capital letter  */
	/* 5a Upper Z			*/	0x5a,	/* Z capital letter  */
	/* 5b			(spare)	*/	0x04,	/* ctrl: EOT	     */
	/* 5c			(spare)	*/	0x05,	/* ctrl: ENQ	     */
	/* 5d Lower y acute		*/	0xfd,	/* y acute	     */
	/* 5e Middle Dot		*/	0xb7,	/* Middle Dot	     */
	/* 5f			(spare)	*/	0x7f,	/* ctrl: delete	     */

	/* 60 Delta Underscore		*/	0x8f,	/* ctrl: reserved    */
	/* 61 A Underscore		*/	0xc1,	/* A acute	     */
	/* 62 B Underscore		*/	0xc2,	/* A circumflex	     */
	/* 63 C Underscore		*/	0xc3,	/* A tilde	     */
	/* 64 D Underscore		*/	0xc7,	/* C cedilla	     */
	/* 65 E Underscore		*/	0xc8,	/* E grave	     */
	/* 66 F Underscore		*/	0xca,	/* E circumflex	     */
	/* 67 G Underscore		*/	0xcb,	/* E diaeresis	     */
	/* 68 H Underscore		*/	0xcc,	/* I grave	     */
	/* 69 I Underscore		*/	0xcd,	/* I acute	     */
	/* 6a J Underscore		*/	0xce,	/* I circumflex	     */
	/* 6b K Underscore		*/	0xcf,	/* I diaeresis	     */
	/* 6c L Underscore		*/	0xd0,	/*   capital ETH     */
	/* 6d M Underscore		*/	0xd2,	/* O grave	     */
	/* 6e N Underscore		*/	0xd3,	/* O acute	     */
	/* 6f O Underscore		*/	0xd4,	/* O circumflex	     */

	/* 70 P Underscore		*/	0xd5,	/* O tilde	     */
	/* 71 Q Underscore		*/	0xd9,	/* U grave	     */
	/* 72 R Underscore		*/	0xda,	/* U acute	     */
	/* 73 S Underscore		*/	0xdb,	/* U circumflex	     */
	/* 74 T Underscore		*/	0xdd,	/* Y acute	     */
	/* 75 U Underscore		*/	0xde,	/*   capital THORN   */
	/* 76 V Underscore		*/	0xe3,	/* a tilde	     */
	/* 77 W Underscore		*/	0xec,	/* i grave	     */
	/* 78 X Underscore		*/	0xf0,	/*   small eth	     */
	/* 79 Y Underscore		*/	0xf2,	/* o grave	     */
	/* 7a Z Underscore		*/	0xf5,	/* o tilde	     */
	/* 7b Left Brace		*/	0x7b,	/* { left brace	     */
	/* 7c Left Tack			*/	0x80,	/* ctrl: reserved    */
	/* 7d Right Brace		*/	0x7d,	/* } right brace     */
	/* 7e RightTack			*/	0x81,	/* ctrl: reserved    */
	/* 7f Squish			*/	0xa6,	/*   broken vert bar */

	/* 80 Each			*/	0xa8,	/* spacing diaeresis */
	/* 81 Upper A grave		*/	0xc0,	/* A grave	     */
	/* 82 Upper A diaeresis		*/	0xc4,	/* A diaeresis	     */
	/* 83 Upper A ring		*/	0xc5,	/* A ring	     */
	/* 84 Upper AE			*/	0xc6,	/* AE		     */
	/* 85 Commute			*/	0xfe,	/* small thorn	     */
	/* 86 Upper E acute		*/	0xc9,	/* E acute	     */
	/* 87 Upper N tilde		*/	0xd1,	/* N tilde	     */
	/* 88 Upper O diaeresis		*/	0xd6,	/* O diaeresis	     */
	/* 89 Upper O slash		*/	0xd8,	/* O slash	     */
	/* 8a Upper U diaeresis		*/	0xdc,	/* U diaeresis	     */
	/* 8b German double-S		*/	0xdf,	/*   small sharp s   */
	/* 8c Lower a grave		*/	0xe0,	/* a grave	     */
	/* 8d Lower a acute		*/	0xe1,	/* a acute	     */
	/* 8e Lower a circumflex	*/	0xe2,	/* a circumflex	     */
	/* 8f Lower a diaeresis		*/	0xe4,	/* a diaeresis	     */

	/* 90 Lower a ring		*/	0xe5,	/* a ring	     */
	/* 91 Lower ae			*/	0xe6,	/* ae		     */
	/* 92 Lower c cedilla		*/	0xe7,	/* c cedilla	     */
	/* 93 Lower e grave		*/	0xe8,	/* e grave	     */
	/* 94 Lower e acute		*/	0xe9,	/* e acute	     */
	/* 95 Lower e circumflex	*/	0xea,	/* e circumflex	     */
	/* 96 Lower e diaeresis		*/	0xeb,	/* e diaeresis	     */
	/* 97 Lower i acute		*/	0xed,	/* i acute	     */
	/* 98 Lower i circumflex	*/	0xee,	/* i circumflex	     */
	/* 99 Lower i diaeresis		*/	0xef,	/* i diaeresis	     */
	/* 9a Lower n tilde		*/	0xf1,	/* n tilde	     */
	/* 9b Left bracket		*/	0x5b,	/* [ left bracket    */
	/* 9c Slash			*/	0x2f,	/* / slash	     */
	/* 9d Slash bar			*/	0x9a,	/* ctrl: reserved    */
	/* 9e Slope			*/	0x5c,	/* \ backslash	     */
	/* 9f Slope bar			*/	0x99,	/* ctrl: reserved    */

	/* a0 Less			*/	0x3c,	/* < less-than sign  */
	/* a1 Less or Equal		*/	0x88,	/* ctrl: reserved    */
	/* a2 Equal			*/	0x3d,	/* = equals sign     */
	/* a3 Greater or Equal		*/	0x89,	/* ctrl: reserved    */
	/* a4 Greater			*/	0x3e,	/* > greater-than    */
	/* a5 Not Equal			*/	0xac,	/*   not sign	     */
	/* a6 Or			*/	0x9f,	/* ctrl: reserved    */
	/* a7 And			*/	0x5e,	/* ^ spacing c'flex  */
	/* a8 Minus			*/	0x2d,	/* - hyphen-minus    */
	/* a9 Plus			*/	0x2b,	/* + plus sign	     */
	/* aa Divide			*/	0xf7,	/*   division sign   */
	/* ab Times			*/	0xd7,	/*   multiply sign   */
	/* ac Query			*/	0x3f,	/* ? question mark   */
	/* ad Epsilon			*/	0xb9,	/*   superscript 1   */
	/* ae Rho			*/	0xbd,	/*   one half	     */
	/* af Tilde			*/	0x7e,	/* ~ tilde	     */

	/* b0 Up Arrow			*/	0x86,	/* ctrl: reserved    */
	/* b1 Down Arrow		*/	0x87,	/* ctrl: reserved    */
	/* b2 Iota			*/	0xbc,	/*   one quarter     */
	/* b3 Circle			*/	0xb1,	/*   plus or minus   */
	/* b4 Star			*/	0x2a,	/* * asterisk	     */
	/* b5 Up stile			*/	0x97,	/* ctrl: reserved    */
	/* b6 Down stile		*/	0x98,	/* ctrl: reserved    */
	/* b7 Del			*/	0x92,	/* ctrl: reserved    */
	/* b8 Jot			*/	0xb0,	/*   degree sign     */
	/* b9 Left parenthesis		*/	0x28,	/* ( left paren	     */
	/* ba Left Shoe			*/	0x9b,	/* ctrl: reserved    */
	/* bb Right Shoe		*/	0x9c,	/* ctrl: reserved    */
	/* bc Up Shoe			*/	0x9d,	/* ctrl: reserved    */
	/* bd Down Shoe			*/	0x9e,	/* ctrl: reserved    */
	/* be Down Tack, Decode		*/	0x83,	/* ctrl: reserved    */
	/* bf Up Tack, Encode		*/	0x82,	/* ctrl: reserved    */

	/* c0 APL Stile			*/	0x7c,	/* | vertical bar    */
	/* c1 Semi-colon		*/	0x3b,	/* ; semicolon	     */
	/* c2 Comma			*/	0x2c,	/* , comma	     */
	/* c3 Nor			*/	0x8b,	/* ctrl: reserved    */
	/* c4 Nand			*/	0x8a,	/* ctrl: reserved    */
	/* c5 Downgrade			*/	0x94,	/* ctrl: reserved    */
	/* c6 Upgrade			*/	0x93,	/* ctrl: reserved    */
	/* c7 Transpose			*/	0xb3,	/*   superscript 3   */
	/* c8 Rotate			*/	0xb2,	/*   superscript 2   */
	/* c9 Rotate bar		*/	0xb4,	/*   spacing acute   */
	/* ca Log			*/	0xb5,	/*   micron sign     */
	/* cb Domino			*/	0x8e,	/* ctrl: reserved    */
	/* cc Shriek			*/	0x21,	/* ! exclamation mark*/
	/* cd Thorn, format		*/	0x95,	/* ctrl: reserved    */
	/* ce Hydrant, execute		*/	0x96,	/* ctrl: reserved    */
	/* cf Del tilde			*/	0x90,	/* ctrl: reserved    */

	/* d0 Cat bar			*/	0xae,	/*   trade mark sign */
	/* d1 Match			*/	0xad,	/*   soft hyphen     */
	/* d2 Natch			*/	0xbb,   /*   right guillemet */
	/* d3 Lower o acute		*/	0xf3,	/* o acute	     */
	/* d4 Lower o circumflex	*/	0xf4,	/* o circumflex	     */
	/* d5 Lower o diaeresis		*/	0xf6,	/* o diaeresis	     */
	/* d6 Lower o slash		*/	0xf8,	/* o slash	     */
	/* d7 Ascii double quote	*/	0x22,	/* " quotation mark  */
	/* d8 Hash			*/	0x23,	/* # number sign     */
	/* d9			(spare)	*/	0x1e,	/* ctrl: RS	     */
	/* da Ampersand			*/	0x26,	/* & ampersand	     */
	/* db Ascii single quote	*/	0x1c,	/* ctrl: FS	     */
	/* dc Line draw lower right	*/	0x10,	/* ctrl: DLE	     */
	/* dd Line draw upper right	*/	0x11,	/* ctrl: DC1	     */
	/* de Line draw upper left	*/	0x12,	/* ctrl: DC2	     */
	/* df Line draw lower left	*/	0x13,	/* ctrl: DC3	     */

	/* e0 Line draw middle cross	*/	0x14,	/* ctrl: DC4	     */
	/* e1 Line draw horizontal bar	*/	0x15,	/* ctrl: NAK	     */
	/* e2 Line draw left  T		*/	0x16,	/* ctrl: SYN	     */
	/* e3 Line draw right T		*/	0x17,	/* ctrl: ETB	     */
	/* e4 Line draw lower T		*/	0x18,	/* ctrl: CAN	     */
	/* e5 Line draw upper T		*/	0x19,	/* ctrl: EM	     */
	/* e6 Line draw vertical bar	*/	0x1a,	/* ctrl: SUB	     */
	/* e7 Ascii at			*/	0x40,	/* @ commercial at   */
	/* e8 Lower u grave		*/	0xf9,	/* u grave	     */
	/* e9 Lower u acute		*/	0xfa,	/* u acute	     */
	/* ea Lower u circumflex	*/	0xfb,	/* u circumflex	     */
	/* eb Ascii caret		*/	0x0f,	/* ctrl: SI	     */
	/* ec Lower u diaeresis		*/	0xfc,	/* u diaeresis	     */
	/* ed Ascii back quote		*/	0x60,	/* ` spacing grave   */
	/* ee Ascii split bar		*/	0x1d,	/* ctrl: GS	     */
	/* ef Paragraph sign		*/	0xb6,	/* paragraph sign    */

	/* f0 Colon			*/	0x3a,	/* : colon	     */
	/* f1 Epsilon underbar (Find)	*/	0xba,	/*   masculine ord'l */
	/* f2 Inverted query		*/	0xbf,	/*   inverted query  */
	/* f3 Inverted shriek		*/	0xa1,	/*   inverted exclm  */
	/* f4 Diamond			*/	0xaa,	/*   feminine ordn'l */
	/* f5 Left Arrow		*/	0x84,	/* ctrl: reserved    */
	/* f6 Right Arrow		*/	0x85,	/* ctrl: reserved    */
	/* f7 Lamp			*/	0xa9,	/*   copyright sign  */
	/* f8 Right parenthesis		*/	0x29,	/* ) right paren     */
	/* f9 Right bracket		*/	0x5d,	/* ] right bracket   */
	/* fa			(spare)	*/	0x1f,	/* ctrl: US	     */
	/* fb			(spare)	*/	0xa0,	/*   non-break space */
	/* fc Section sign		*/	0xa7,	/* section sign	     */
	/* fd Quad			*/	0x8c,	/* ctrl: reserved    */
	/* fe Quote Quad		*/	0x8d,	/* ctrl: reserved    */
	/* ff Lower y diaeresis		*/	0xff	/* y diaeresis	     */

,/*C234*/ 255,  0,  0	// Native File			Red on...
,/*B234*/   0,  0,  0	// Native File			...Black

,/*C235*/ 255,  0,  0	// Native File (Read-only)	Red on...
,/*B235*/ 130,130,130	// Native File (Read-only)	...Dark Grey

,/*C236*/   0,255,  0	// Char Array			Green on...
,/*B236*/   0,  0,  0	// Char Array			...Black

,/*C237*/   0,255,  0	// Char Array (Read-only)	Green on...
,/*B237*/ 130,130,130	// Char Array			...Dark Grey

,/*C238*/ 255,255,255	// Numeric Array			White on...
,/*B238*/   0,  0,  0	// Numeric Array			...Black

,/*C239*/ 255,255,255	// Numeric Array	(Read-only)  	White on...
,/*B239*/ 130,130,130	// Numeric Array (Read-only)	...Dark Grey

,/*C240*/   0,255,255	// Mixed Array			Cyan on ...
,/*B240*/   0,  0,  0	// Mixed Array			...Black

,/*C241*/   0,255,255	// Mixed Array (Read-only)	Cyan on ...
,/*B241*/ 130,130,130	// Mixed Array (Read-only)	...Dark Grey

,/*C242*/   0,255,255	// Nested Array			Cyan on ...
,/*B242*/   0,  0,  0	// Nested Array			...Black

,/*C243*/   0,255,255	// Nested Array (Read-only)	Cyan on ...
,/*B243*/ 130,130,130	// Nested Array (Read-only)	...Dark Grey

,/*C244*/ 255,255,255	// QuadOR Object			White on...
,/*B244*/ 255,  0,  0	// QuadOR Object			...Red	

,/*C245*/ 255,255,255	// QuadOR Object	(Read-only)	White on...
,/*B245*/ 255,  0,  0	// QuadOR Object	(Read-only)	...Red	

,/*C248*/ 255,255,255	// Edit Function	(Read-only)	White on...
,/*B248*/   0,128,128	// Edit Function	(Read-only)	...Dark Cyan

,/*C249*/ 255,  0,  0	// marked line			Red on...
,/*B249*/ 255,255,255	// marked line			...White

,/*C250*/   0,  0,  0	// session			Black on...
,/*B250*/ 255,255,255	// session			...White


,/*C252*/ 255,255,  0	// Suspended Function		Yellow on...
,/*B252*/   0,  0,  0	// Suspended Function		...Black

,/*C253*/ 255,255,  0	// Pendent Function		Yellow on...
,/*B253*/ 128,128,128	// Pendent Function		...Dark Grey

,/*C254*/   0,  0,  0	// Edit Function			White on...
,/*B254*/ 192,192,192	// Edit Function			...Blue

,/*C255*/ 255,255,255	// Hilite			White on...
,/*B255*/ 255,  0,  0	// Hilite			...Red

,/*C0*/  192,192,192	// White (dim)
,/*B0*/    0,  0,  0	// Black
,/*C1*/    0,  0,128	// Dk Blue
,/*B1*/    0,  0,128	// Dk Blue
,/*C2*/    0,128,  0	// Dk Green
,/*B2*/    0,128,  0	// Dk Green
,/*C3*/    0,130,130	// Dk Cyan
,/*B3*/    0,130,130	// Dk Cyan
,/*C4*/  128,  0,  0	// Dk Red
,/*B4*/  128,  0,  0	// Dk Red
,/*C5*/  128,  0,128	// Dk Magenta
,/*B5*/  128,  0,128	// Dk Magenta 
,/*C6*/  128,128,  0	// Dk Yellow
,/*B6*/  128,128,  0	// Dk Yellow 
,/*C7*/    0,  0,  0	// Black
,/*B7*/  192,192,192	// White (dim)
,/*C8*/  255,255,255	// White (Intense)
,/*B8*/  255,255,255	// White (Intense)
,/*C9*/    0,  0,255	// Blue
,/*B9*/    0,  0,255	// Blue
,/*C10*/   0,255,  0	// Green
,/*B10*/   0,255,  0	// Green
,/*C11*/   0,255,255	// Cyan
,/*B11*/   0,255,255	// Cyan
,/*C12*/ 255,  0,  0	// Red
,/*B12*/ 255,  0,  0	// Red
,/*C13*/ 255,  0,255	// Magenta
,/*B13*/ 255,  0,255	// Magenta
,/*C14*/ 255,255,  0	// Yellow
,/*B14*/ 255,255,  0	// Yellow
,/*C15*/ 130,130,130	// Grey
,/*B15*/ 130,130,130	// Grey

,/*C129*/ 255,  0,  0	// Syntax Error			
,/*B129*/ 255,255,255	// Syntax Error		
,/*C130*/   0,  0,255	// Syntax Line Numbers
,/*B130*/ 255,255,255	// Syntax Line Numbers
,/*C131*/   0,  0,128	// Syntax System Function
,/*B131*/ 255,255,255	// Syntax System Function
,/*C132*/   0,  0,255	// Syntax Primitive	
,/*B132*/ 255,255,255	// Syntax Primitive
,/*C133*/   0,  0,128	// Syntax Label	
,/*B133*/ 255,255,255	// Syntax Label	
,/*C134*/ 128,128,128	// Syntax Local Name	
,/*B134*/ 255,255,255	// Syntax Local Name
,/*C135*/   0,  0,  0	// Syntax Global Name
,/*B135*/ 255,255,255	// Syntax Global Name
,/*C136*/ 128,128,128	// Syntax Numeric Const
,/*B136*/ 255,255,255	// Syntax Numeric Const
,/*C137*/   0,128,  0	// Syntax Comment
,/*B137*/ 255,255,255	// Syntax Comment
,/*C138*/ 128,  0,  0	// Syntax Control Str.	
,/*B138*/ 255,255,255	// Syntax Control Str.	
,/*C139*/   0,128,128	// Syntax String Const	
,/*B139*/ 255,255,255	// Syntax String Const	
,/*C140*/ 128,  0,128	// Syntax local Sys Var	
,/*B140*/ 255,255,255	// Syntax local Sys Var	
,/*C141*/   0,  0,  0	// Syntax Global Sys Var
,/*B141*/ 255,255,255	// Syntax Global Sys Var
,/*C142*/ 128,128,128	// Syntax name in Dfn
,/*B142*/ 255,255,255	// Syntax name in Dfn
,/*C143*/   0,  0,255	// D-Op {dyadic}
,/*B143*/ 255,255,255	// D-Op {dyadic}
,/*C144*/   0,  0,255	// D-Op {monadic}
,/*B144*/ 255,255,255	// D-Op {monadic}

,/*C100*/   0,128,  0	// Status Info	
,/*B100*/ 255,255,255	// Status Info	
,/*C101*/ 255,  0,  0	// Status Error
,/*B101*/ 255,255,255	// Status Error
,/*C102*/   0,  0,255	// Status Warning
,/*B102*/ 255,255,255	// Status Warning

};

// 'Raw' String Translation Functions:

static unsigned char *RawAnsi = 0;		// Raw ANSI input  for ansi2av	
static unsigned char *RawAnso = av_ansi_dflt;	// Raw ANSI output for av2ansi	

void av2ansi(unsigned char *cptr, int size)
{
	while (size--)
	{
		unsigned ch = *cptr;
		*cptr++ = RawAnso[ch];
	}
}

static void MakeRawXtab()
{
	unsigned char code;
	int indx;

	RawAnsi = malloc(256);

	if(0 == RawAnsi) error(10);	// limit()

	// note that the 1 - 1 nature of the table makes initialisation 
	// unnecessary

	for (indx=256; indx--;)
	{
		code = RawAnso[indx];
		RawAnsi[code] = indx;
	}
}

void ansi2av(unsigned char *cptr, int size)
{
	if (RawAnsi == 0)			// initialise first time used.
		MakeRawXtab();

	while (size--)
	{
		unsigned ch = *cptr;
		*cptr++ = RawAnsi[ch];
	}
}

#define	RAWOFF(n)	(256 + (3 * n))

static struct Sas raw_sas[] =
	{
		{ C0 - 234, RAWOFF( 0), 3 }
	,	{ B0 - 234, RAWOFF( 1), 3 }
	,	{ C0 - 235, RAWOFF( 2), 3 }
	,	{ B0 - 235, RAWOFF( 3), 3 }
	,	{ C0 - 236, RAWOFF( 4), 3 }
	,	{ B0 - 236, RAWOFF( 5), 3 }
	,	{ C0 - 237, RAWOFF( 6), 3 }
	,	{ B0 - 237, RAWOFF( 7), 3 }
	,	{ C0 - 238, RAWOFF( 8), 3 }
	,	{ B0 - 238, RAWOFF( 9), 3 }
	,	{ C0 - 239, RAWOFF(10), 3 }
	,	{ B0 - 239, RAWOFF(11), 3 }
	,	{ C0 - 240, RAWOFF(12), 3 }
	,	{ B0 - 240, RAWOFF(13), 3 }
	,	{ C0 - 241, RAWOFF(14), 3 }
	,	{ B0 - 241, RAWOFF(15), 3 }
	,	{ C0 - 242, RAWOFF(16), 3 }
	,	{ B0 - 242, RAWOFF(17), 3 }
	,	{ C0 - 243, RAWOFF(18), 3 }
	,	{ B0 - 243, RAWOFF(19), 3 }
	,	{ C0 - 244, RAWOFF(20), 3 }
	,	{ B0 - 244, RAWOFF(21), 3 }
	,	{ C0 - 245, RAWOFF(22), 3 }
	,	{ B0 - 245, RAWOFF(23), 3 }
	,	{ C0 - 248, RAWOFF(24), 3 }
	,	{ B0 - 248, RAWOFF(25), 3 }
	,	{ C0 - 249, RAWOFF(26), 3 }
	,	{ B0 - 249, RAWOFF(27), 3 }
	,	{ C0 - 250, RAWOFF(28), 3 }
	,	{ B0 - 250, RAWOFF(29), 3 }
	,	{ C0 - 252, RAWOFF(30), 3 }
	,	{ B0 - 252, RAWOFF(31), 3 }
	,	{ C0 - 253, RAWOFF(32), 3 }
	,	{ B0 - 253, RAWOFF(33), 3 }
	,	{ C0 - 254, RAWOFF(34), 3 }
	,	{ B0 - 254, RAWOFF(35), 3 }
	,	{ C0 - 255, RAWOFF(36), 3 }
	,	{ B0 - 255, RAWOFF(37), 3 }
	,	{ C0 -   0, RAWOFF(38), 3 }
	,	{ B0 -   0, RAWOFF(39), 3 }
	,	{ C0 -   1, RAWOFF(40), 3 }
	,	{ B0 -   1, RAWOFF(41), 3 }
	,	{ C0 -   2, RAWOFF(42), 3 }
	,	{ B0 -   2, RAWOFF(43), 3 }
	,	{ C0 -   3, RAWOFF(44), 3 }
	,	{ B0 -   3, RAWOFF(45), 3 }
	,	{ C0 -   4, RAWOFF(46), 3 }
	,	{ B0 -   4, RAWOFF(47), 3 }
	,	{ C0 -   5, RAWOFF(48), 3 }
	,	{ B0 -   5, RAWOFF(49), 3 }
	,	{ C0 -   6, RAWOFF(50), 3 }
	,	{ B0 -   6, RAWOFF(51), 3 }
	,	{ C0 -   7, RAWOFF(52), 3 }
	,	{ B0 -   7, RAWOFF(53), 3 }
	,	{ C0 -   8, RAWOFF(54), 3 }
	,	{ B0 -   8, RAWOFF(55), 3 }
	,	{ C0 -   9, RAWOFF(56), 3 }
	,	{ B0 -   9, RAWOFF(57), 3 }
	,	{ C0 -  10, RAWOFF(58), 3 }
	,	{ B0 -  10, RAWOFF(59), 3 }
	,	{ C0 -  11, RAWOFF(60), 3 }
	,	{ B0 -  11, RAWOFF(61), 3 }
	,	{ C0 -  12, RAWOFF(62), 3 }
	,	{ B0 -  12, RAWOFF(63), 3 }
	,	{ C0 -  13, RAWOFF(64), 3 }
	,	{ B0 -  13, RAWOFF(65), 3 }
	,	{ C0 -  14, RAWOFF(66), 3 }
	,	{ B0 -  14, RAWOFF(67), 3 }
	,	{ C0 -  15, RAWOFF(68), 3 }
	,	{ B0 -  15, RAWOFF(69), 3 }
	,	{ C0 - 129, RAWOFF(70), 3 }
	,	{ B0 - 129, RAWOFF(71), 3 }
	,	{ C0 - 130, RAWOFF(72), 3 }
	,	{ B0 - 130, RAWOFF(73), 3 }
	,	{ C0 - 131, RAWOFF(74), 3 }
	,	{ B0 - 131, RAWOFF(75), 3 }
	,	{ C0 - 132, RAWOFF(76), 3 }
	,	{ B0 - 132, RAWOFF(77), 3 }
	,	{ C0 - 133, RAWOFF(78), 3 }
	,	{ B0 - 133, RAWOFF(79), 3 }
	,	{ C0 - 134, RAWOFF(80), 3 }
	,	{ B0 - 134, RAWOFF(81), 3 }
	,	{ C0 - 135, RAWOFF(82), 3 }
	,	{ B0 - 135, RAWOFF(83), 3 }
	,	{ C0 - 136, RAWOFF(84), 3 }
	,	{ B0 - 136, RAWOFF(85), 3 }
	,	{ C0 - 137, RAWOFF(86), 3 }
	,	{ B0 - 137, RAWOFF(87), 3 }
	,	{ C0 - 138, RAWOFF(88), 3 }
	,	{ B0 - 138, RAWOFF(89), 3 }
	,	{ C0 - 139, RAWOFF(90), 3 }
	,	{ B0 - 139, RAWOFF(91), 3 }
	,	{ C0 - 140, RAWOFF(92), 3 }
	,	{ B0 - 140, RAWOFF(93), 3 }
	,	{ C0 - 141, RAWOFF(94), 3 }
	,	{ B0 - 141, RAWOFF(95), 3 }
	,	{ C0 - 142, RAWOFF(96), 3 }
	,	{ B0 - 142, RAWOFF(97), 3 }
	,	{ C0 - 143, RAWOFF(98), 3 }
	,	{ B0 - 143, RAWOFF(99), 3 }
	,	{ C0 - 144, RAWOFF(100), 3 }
	,	{ B0 - 144, RAWOFF(101), 3 }
	,	{ C0 - 100, RAWOFF(102), 3 }
	,	{ B0 - 100, RAWOFF(103), 3 }
	,	{ C0 - 101, RAWOFF(104), 3 }
	,	{ B0 - 101, RAWOFF(105), 3 }
	,	{ C0 - 102, RAWOFF(106), 3 }
	,	{ B0 - 102, RAWOFF(107), 3 }

	};

static short unsigned raw_offsets[] =
	{
	 0,  1,  2,  3,  4,  5,  6,  7,  8,  9
,	10, 11, 12, 13, 14, 15, 16, 17, 18, 19
,	20, 21, 22, 23, 24, 25, 26, 27, 28, 29
,	30, 31, 32, 33, 34, 35, 36, 37, 38, 39
,	40, 41, 42, 43, 44, 45, 46, 47, 48, 49
,	50, 51, 52, 53, 54, 55, 56, 57, 58, 59
,	60, 61, 62, 63, 64, 65, 66, 67, 68, 69
,	70, 71, 72, 73, 74, 75, 76, 77, 78, 79
,	80, 81, 82, 83, 84, 85, 86, 87, 88, 89
,	90, 91, 92, 93, 94, 95, 96, 97, 98, 99
,	100, 101, 102, 103, 104, 105, 106, 107, 108, 109
,	110, 111, 112, 113, 114, 115, 116, 117, 118, 119
,	120, 121, 122, 123, 124, 125, 126, 127, 128, 129
,	130, 131, 132, 133, 134, 135, 136, 137, 138, 139
,	140, 141, 142, 143, 144, 145, 146, 147, 148, 149
,	150, 151, 152, 153, 154, 155, 156, 157, 158, 159
,	160, 161, 162, 163, 164, 165, 166, 167, 168, 169
,	170, 171, 172, 173, 174, 175, 176, 177, 178, 179
,	180, 181, 182, 183, 184, 185, 186, 187, 188, 189
,	190, 191, 192, 193, 194, 195, 196, 197, 198, 199
,	200, 201, 202, 203, 204, 205, 206, 207, 208, 209
,	210, 211, 212, 213, 214, 215, 216, 217, 218, 219
,	220, 221, 222, 223, 224, 225, 226, 227, 228, 229
,	230, 231, 232, 233, 234, 235, 236, 237, 238, 239
,	240, 241, 242, 243, 244, 245, 246, 247, 248, 249
,	250, 251, 252, 253, 254, 255
,	0					// CC
	};

static unsigned char raw_lengths[] =
	{
	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
,	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
,	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
,	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
,	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
,	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
,	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
,	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
,	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
,	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
,	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
,	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
,	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
,	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
,	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
,	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
,	0					// CC
	};

static struct Translate raw_output =
	{
	(~0)			// inode
,	(~0)			// device
,	1			// just one mode
,	(sizeof(raw_sas) / sizeof(struct Sas))		// colours
,	raw_sas
,	raw_offsets
,	raw_lengths
,	av_ansi_dflt
	};

static struct Out_fd raw_fd =
	{
	&raw_output
,	(~0)
,	(~0)
,	0
,	0
	};

static unsigned char ScanMap[256];

void s_fname	// develop an input file name 
	(
	unsigned char *tp		// null or target file name 
,	unsigned char *buf		// where to put the file name 
,	unsigned errflag		// is this an error 
	)
	{
	t_fname(tp, "APLKEYS", "aplkeys", "APLS  ", ".SCN", buf, errflag);
	}

static ReadScanMap()
{
char filename[MAXFCHARS];
char *buf,*cp,*ep;
char VirtMap[256];
int VirtKey,ScanCode,fh,comma;

if (shad_getenv("APLS"))
	{
	fname=s_fname; (*fname)(0, filename, 0);

	if (-1 != (fh=t_fopen(filename,"\n")))
		{
		cp=buf=alloca(trans_size);
		if (buf) 
			{
			memset(VirtMap,0,256);
			if (trans_size!=read(fh,buf,trans_size))
				(*x_error)(CANT_READ);

			TrimDosFile(buf);
			if(buf[trans_size-1] != '\n')
				(*x_error)(NOT_ASCII);

			while (cp<buf+trans_size)
				{
				comma=VirtKey=ScanCode=0;
				ep=strchr(cp,'\n');
				curr_start_of_line = ep-1;

				cp=white(cp,ep);
				if('+'==*cp)cp=comment(cp,ep);
				if(','==*cp)cp+=comma=1;
				if(cp!=ep) cp=white (cp,ep);
				if(cp!=ep) cp=number(cp,ep),VirtKey=lastnumber;
				if(cp!=ep) cp=white (cp,ep);
				if('+'==*cp)cp=comment(cp,ep);
				if(cp!=ep) cp=number(cp,ep),ScanCode=lastnumber;
				if(cp!=ep) cp=white (cp,ep);
				cp=comment(cp,ep);

				if (VirtKey && ScanCode)
					{
					if (ScanMap[ScanCode])
						(*x_error)(DUP_STRING);

					if (0==comma && VirtMap[VirtKey])
						(*x_error)(DUP_STRING);
					
					ScanMap[ScanCode]=VirtKey;
					VirtMap[VirtKey]=1;
					}
				cp=ep+1;
				}
			}
		else
			(*x_error)(FILE2BIG);
		close(fh);
		}
	}
}


int MapScanCode(int sc,int vk)
{
return ScanMap[sc] ? ScanMap[sc] : vk;
}


#ifndef rmemcpy

void rmemcpy(to, fm, n)				// reverse memcpy	     
register char *to, *fm;
register int n;
{
	to += n;				// NOTE, great benefits will 
	fm += n;				// almost certainly accrue   
						// if this and the next fun  
	while (n--)				// are replaced by corresp.  
		*--to = *--fm;			// library equivalents       
}

#endif // rmemcpy 

#ifndef fmemcpy

void fmemcpy(to, fm, n)				// forward memcpy	     
register char *to, *fm;
register int n;
{
	while (n--)
		*to++ = *fm++;
}

#endif // fmemcpy 
//	Copyright (c) 1982 Dyadic Systems Limited	


/*	linecode
	Get linecode from apl array or error.

	Null character vectors return NOKEY.
*/

